<?php
/**
 * Automatically generated by running "php schema.php datetime".
 *
 * You may modify the file, but re-running schema.php against this file will
 * standardize the format without losing your schema changes. It does lose
 * any changes that are not part of schema. Use "note" field to comment on
 * schema itself, and "note" fields are not used in any code generation but
 * only staying within this file.
 */
///////////////////////////////////////////////////////////////////////////////
// Preamble: C++ code inserted at beginning of ext_{name}.h

DefinePreamble(<<<CPP

CPP
);

///////////////////////////////////////////////////////////////////////////////
// Constants
//
// array (
//   'name' => name of the constant
//   'type' => type of the constant
//   'note' => additional note about this constant's schema
// )


///////////////////////////////////////////////////////////////////////////////
// Functions
//
// array (
//   'name'   => name of the function
//   'desc'   => description of the function's purpose
//   'flags'  => attributes of the function, see base.php for possible values
//   'opt'    => optimization callback function's name for compiler
//   'note'   => additional note about this function's schema
//   'return' =>
//      array (
//        'type'  => return type, use Reference for ref return
//        'desc'  => description of the return value
//      )
//   'args'   => arguments
//      array (
//        'name'  => name of the argument
//        'type'  => type of the argument, use Reference for output parameter
//        'value' => default value of the argument
//        'desc'  => description of the argument
//      )
// )

DefineFunction(
  array(
    'name'   => "checkdate",
    'desc'   => "Checks the validity of the date formed by the arguments. A date is considered valid if each parameter is properly defined.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE if the date given is valid; otherwise returns FALSE.",
    ),
    'args'   => array(
      array(
        'name'   => "month",
        'type'   => Int32,
        'desc'   => "The month is between 1 and 12 inclusive.",
      ),
      array(
        'name'   => "day",
        'type'   => Int32,
        'desc'   => "The day is within the allowed number of days for the given month. Leap years are taken into consideration.",
      ),
      array(
        'name'   => "year",
        'type'   => Int32,
        'desc'   => "The year is between 1 and 32767 inclusive.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "date_create",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Object,
    ),
    'args'   => array(
      array(
        'name'   => "time",
        'type'   => String,
        'value'  => "null_string",
      ),
      array(
        'name'   => "timezone",
        'type'   => Object,
        'value'  => "null_object",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "date_date_set",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => null,
    ),
    'args'   => array(
      array(
        'name'   => "object",
        'type'   => Object,
      ),
      array(
        'name'   => "year",
        'type'   => Int32,
      ),
      array(
        'name'   => "month",
        'type'   => Int32,
      ),
      array(
        'name'   => "day",
        'type'   => Int32,
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "date_default_timezone_get",
    'desc'   => "In order of preference, this function returns the default timezone by:\n\nReading the timezone set using the date_default_timezone_set() function (if any)\n\nReading the TZ environment variable (if non empty) (Prior to PHP 5.3.0)\n\nReading the value of the date.timezone ini option (if set)\n\nQuerying the host operating system (if supported and allowed by the OS)\n\nIf none of the above succeed, date_default_timezone_get() will return a default timezone of UTC.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "Returns a string.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "date_default_timezone_set",
    'desc'   => "date_default_timezone_set() sets the default timezone used by all date/time functions.\n\nSince PHP 5.1.0 (when the date/time functions were rewritten), every call to a date/time function will generate a E_NOTICE if the timezone isn't valid, and/or a E_WARNING message if using the system settings or the TZ environment variable.\n\nInstead of using this function to set the default timezone in your script, you can also use the INI setting date.timezone to set the default timezone.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "This function returns FALSE if the timezone_identifier isn't valid, or TRUE otherwise.",
    ),
    'args'   => array(
      array(
        'name'   => "name",
        'type'   => String,
        'desc'   => "The timezone identifier, like UTC or Europe/Lisbon. The list of valid identifiers is available in the List of Supported Timezones.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "date_format",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
    ),
    'args'   => array(
      array(
        'name'   => "object",
        'type'   => Object,
      ),
      array(
        'name'   => "format",
        'type'   => String,
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "date_isodate_set",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => null,
    ),
    'args'   => array(
      array(
        'name'   => "object",
        'type'   => Object,
      ),
      array(
        'name'   => "year",
        'type'   => Int32,
      ),
      array(
        'name'   => "week",
        'type'   => Int32,
      ),
      array(
        'name'   => "day",
        'type'   => Int32,
        'value'  => "1",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "date_modify",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => null,
    ),
    'args'   => array(
      array(
        'name'   => "object",
        'type'   => Object,
      ),
      array(
        'name'   => "modify",
        'type'   => String,
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "date_offset_get",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int32,
    ),
    'args'   => array(
      array(
        'name'   => "object",
        'type'   => Object,
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "date_parse",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns array with information about the parsed date on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "date",
        'type'   => String,
        'desc'   => "Date in format accepted by strtotime().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "date_sun_info",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => VariantMap,
      'desc'   => "Returns array on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "ts",
        'type'   => Int64,
        'desc'   => "Timestamp.",
      ),
      array(
        'name'   => "latitude",
        'type'   => Double,
        'desc'   => "Latitude in degrees.",
      ),
      array(
        'name'   => "longitude",
        'type'   => Double,
        'desc'   => "Longitude in degrees.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "date_sunrise",
    'desc'   => "date_sunrise() returns the sunrise time for a given day (specified as a timestamp) and location.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the sunrise time in a specified format on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "timestamp",
        'type'   => Int64,
        'desc'   => "The timestamp of the day from which the sunrise time is taken.",
      ),
      array(
        'name'   => "format",
        'type'   => Int32,
        'value'  => "0",
        'desc'   => "format constants constant description example SUNFUNCS_RET_STRING returns the result as string 16:46 SUNFUNCS_RET_DOUBLE returns the result as float 16.78243132 SUNFUNCS_RET_TIMESTAMP returns the result as integer (timestamp) 1095034606",
      ),
      array(
        'name'   => "latitude",
        'type'   => Double,
        'value'  => "0.0",
        'desc'   => "Defaults to North, pass in a negative value for South. See also: date.default_latitude",
      ),
      array(
        'name'   => "longitude",
        'type'   => Double,
        'value'  => "0.0",
        'desc'   => "Defaults to East, pass in a negative value for West. See also: date.default_longitude",
      ),
      array(
        'name'   => "zenith",
        'type'   => Double,
        'value'  => "0.0",
        'desc'   => "Default: date.sunrise_zenith",
      ),
      array(
        'name'   => "gmt_offset",
        'type'   => Double,
        'value'  => "99999.0",
        'desc'   => "Specified in hours.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "date_sunset",
    'desc'   => "date_sunset() returns the sunset time for a given day (specified as a timestamp) and location.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the sunset time in a specified format on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "timestamp",
        'type'   => Int64,
        'desc'   => "The timestamp of the day from which the sunset time is taken.",
      ),
      array(
        'name'   => "format",
        'type'   => Int32,
        'value'  => "0",
        'desc'   => "format constants constant description example SUNFUNCS_RET_STRING returns the result as string 16:46 SUNFUNCS_RET_DOUBLE returns the result as float 16.78243132 SUNFUNCS_RET_TIMESTAMP returns the result as integer (timestamp) 1095034606",
      ),
      array(
        'name'   => "latitude",
        'type'   => Double,
        'value'  => "0.0",
        'desc'   => "Defaults to North, pass in a negative value for South. See also: date.default_latitude",
      ),
      array(
        'name'   => "longitude",
        'type'   => Double,
        'value'  => "0.0",
        'desc'   => "Defaults to East, pass in a negative value for West. See also: date.default_longitude",
      ),
      array(
        'name'   => "zenith",
        'type'   => Double,
        'value'  => "0.0",
        'desc'   => "Default: date.sunset_zenith",
      ),
      array(
        'name'   => "gmt_offset",
        'type'   => Double,
        'value'  => "99999.0",
        'desc'   => "Specified in hours.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "date_time_set",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => null,
    ),
    'args'   => array(
      array(
        'name'   => "object",
        'type'   => Object,
      ),
      array(
        'name'   => "hour",
        'type'   => Int32,
      ),
      array(
        'name'   => "minute",
        'type'   => Int32,
      ),
      array(
        'name'   => "second",
        'type'   => Int32,
        'value'  => "0",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "date_timezone_get",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
    ),
    'args'   => array(
      array(
        'name'   => "object",
        'type'   => Object,
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "date_timezone_set",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => null,
    ),
    'args'   => array(
      array(
        'name'   => "object",
        'type'   => Object,
      ),
      array(
        'name'   => "timezone",
        'type'   => Object,
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "date",
    'desc'   => "Returns a string formatted according to the given format string using the given integer timestamp or the current time if no timestamp is given. In other words, timestamp is optional and defaults to the value of time().",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns a formatted date string. If a non-numeric value is used for timestamp, FALSE is returned and an E_WARNING level error is emitted.",
    ),
    'args'   => array(
      array(
        'name'   => "format",
        'type'   => String,
      ),
      array(
        'name'   => "timestamp",
        'type'   => Int64,
        'value'  => "TimeStamp::Current()",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "getdate",
    'desc'   => "Returns an associative array containing the date information of the timestamp, or the current local time if no timestamp is given.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => VariantMap,
    ),
    'args'   => array(
      array(
        'name'   => "timestamp",
        'type'   => Int64,
        'value'  => "TimeStamp::Current()",
        'desc'   => "The optional timestamp parameter is an integer Unix timestamp that defaults to the current local time if a timestamp is not given. In other words, it defaults to the value of time().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "gettimeofday",
    'desc'   => "This is an interface to gettimeofday(2). It returns an associative array containing the data returned from the system call.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "By default an array is returned. If return_float is set, then a float is returned.\n\nArray keys: \"sec\" - seconds since the Unix Epoch \"usec\" - microseconds \"minuteswest\" - minutes west of Greenwich \"dsttime\" - type of dst correction",
    ),
    'args'   => array(
      array(
        'name'   => "return_float",
        'type'   => Boolean,
        'value'  => "false",
        'desc'   => "When set to TRUE, a float instead of an array is returned.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "gmdate",
    'desc'   => "Identical to the date() function except that the time returned is Greenwich Mean Time (GMT).",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns a formatted date string. If a non-numeric value is used for timestamp, FALSE is returned and an E_WARNING level error is emitted.",
    ),
    'args'   => array(
      array(
        'name'   => "format",
        'type'   => String,
        'desc'   => "The format of the outputted date string. See the formatting options for the date() function.",
      ),
      array(
        'name'   => "timestamp",
        'type'   => Int64,
        'value'  => "TimeStamp::Current()",
        'desc'   => "The optional timestamp parameter is an integer Unix timestamp that defaults to the current local time if a timestamp is not given. In other words, it defaults to the value of time().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "gmmktime",
    'desc'   => "Identical to mktime() except the passed parameters represents a GMT date. gmmktime() internally uses mktime() so only times valid in derived local time can be used.\n\nLike mktime(), arguments may be left out in order from right to left, with any omitted arguments being set to the current corresponding GMT value.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns a integer Unix timestamp.",
    ),
    'args'   => array(
      array(
        'name'   => "hour",
        'type'   => Int32,
        'value'  => "INT_MAX",
        'desc'   => "The hour",
      ),
      array(
        'name'   => "minute",
        'type'   => Int32,
        'value'  => "INT_MAX",
        'desc'   => "The minute",
      ),
      array(
        'name'   => "second",
        'type'   => Int32,
        'value'  => "INT_MAX",
        'desc'   => "The second",
      ),
      array(
        'name'   => "month",
        'type'   => Int32,
        'value'  => "INT_MAX",
        'desc'   => "The month",
      ),
      array(
        'name'   => "day",
        'type'   => Int32,
        'value'  => "INT_MAX",
        'desc'   => "The day",
      ),
      array(
        'name'   => "year",
        'type'   => Int32,
        'value'  => "INT_MAX",
        'desc'   => "The year",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "gmstrftime",
    'desc'   => "Behaves the same as strftime() except that the time returned is Greenwich Mean Time (GMT). For example, when run in Eastern Standard Time (GMT -0500), the first line below prints \"Dec 31 1998 20:00:00\", while the second prints \"Jan 01 1999 01:00:00\".",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "Returns a string formatted according to the given format string using the given timestamp or the current local time if no timestamp is given. Month and weekday names and other language dependent strings respect the current locale set with setlocale().",
    ),
    'args'   => array(
      array(
        'name'   => "format",
        'type'   => String,
        'desc'   => "See description in strftime().",
      ),
      array(
        'name'   => "timestamp",
        'type'   => Int64,
        'value'  => "TimeStamp::Current()",
        'desc'   => "The optional timestamp parameter is an integer Unix timestamp that defaults to the current local time if a timestamp is not given. In other words, it defaults to the value of time().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "idate",
    'desc'   => "Returns a number formatted according to the given format string using the given integer timestamp or the current local time if no timestamp is given. In other words, timestamp is optional and defaults to the value of time().\n\nUnlike the function date(), idate() accepts just one char in the format parameter.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an integer.\n\nAs idate() always returns an integer and as they can't start with a \"0\", idate() may return fewer digits than you would expect. See the example below.",
    ),
    'args'   => array(
      array(
        'name'   => "format",
        'type'   => String,
        'desc'   => "The following characters are recognized in the format parameter string format character Description B Swatch Beat/Internet Time d Day of the month h Hour (12 hour format) H Hour (24 hour format) i Minutes I (uppercase i) returns 1 if DST is activated, 0 otherwise L (uppercase l) returns 1 for leap year, 0 otherwise m Month number s Seconds t Days in current month U Seconds since the Unix Epoch - January 1 1970 00:00:00 UTC - this is the same as time() w Day of the week (0 on Sunday) W ISO-8601 week number of year, weeks starting on Monday y Year (1 or 2 digits - check note below) Y Year (4 digits) z Day of the year Z Timezone offset in seconds",
      ),
      array(
        'name'   => "timestamp",
        'type'   => Int64,
        'value'  => "TimeStamp::Current()",
        'desc'   => "The optional timestamp parameter is an integer Unix timestamp that defaults to the current local time if a timestamp is not given. In other words, it defaults to the value of time().",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "localtime",
    'desc'   => "The localtime() function returns an array identical to that of the structure returned by the C function call.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => VariantMap,
    ),
    'args'   => array(
      array(
        'name'   => "timestamp",
        'type'   => Int64,
        'value'  => "TimeStamp::Current()",
        'desc'   => "The optional timestamp parameter is an integer Unix timestamp that defaults to the current local time if a timestamp is not given. In other words, it defaults to the value of time().",
      ),
      array(
        'name'   => "is_associative",
        'type'   => Boolean,
        'value'  => "false",
        'desc'   => "If set to FALSE or not supplied then the array is returned as a regular, numerically indexed array. If the argument is set to TRUE then localtime() returns an associative array containing all the different elements of the structure returned by the C function call to localtime. The names of the different keys of the associative array are as follows:\n\n\"tm_sec\" - seconds \"tm_min\" - minutes \"tm_hour\" - hour \"tm_mday\" - day of the month Months are from 0 (Jan) to 11 (Dec) and days of the week are from 0 (Sun) to 6 (Sat). \"tm_mon\" - month of the year, starting with 0 for January \"tm_year\" - Years since 1900 \"tm_wday\" - Day of the week \"tm_yday\" - Day of the year \"tm_isdst\" - Is daylight savings time in effect",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "microtime",
    'desc'   => "microtime() returns the current Unix timestamp with microseconds. This function is only available on operating systems that support the gettimeofday() system call.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
    ),
    'args'   => array(
      array(
        'name'   => "get_as_float",
        'type'   => Boolean,
        'value'  => "false",
        'desc'   => "When called without the optional argument, this function returns the string \"msec sec\" where sec is the current time measured in the number of seconds since the Unix Epoch (0:00:00 January 1, 1970 GMT), and msec is the microseconds part. Both portions of the string are returned in units of seconds.\n\nIf the optional get_as_float is set to TRUE then a float (in seconds) is returned.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mktime",
    'desc'   => "Returns the Unix timestamp corresponding to the arguments given. This timestamp is a long integer containing the number of seconds between the Unix Epoch (January 1 1970 00:00:00 GMT) and the time specified.\n\nArguments may be left out in order from right to left; any arguments thus omitted will be set to the current value according to the local date and time.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "mktime() returns the Unix timestamp of the arguments given. If the arguments are invalid, the function returns FALSE (before PHP 5.1 it returned -1).",
    ),
    'args'   => array(
      array(
        'name'   => "hour",
        'type'   => Int32,
        'value'  => "INT_MAX",
        'desc'   => "The number of the hour.",
      ),
      array(
        'name'   => "minute",
        'type'   => Int32,
        'value'  => "INT_MAX",
        'desc'   => "The number of the minute.",
      ),
      array(
        'name'   => "second",
        'type'   => Int32,
        'value'  => "INT_MAX",
        'desc'   => "The number of seconds past the minute.",
      ),
      array(
        'name'   => "month",
        'type'   => Int32,
        'value'  => "INT_MAX",
        'desc'   => "The number of the month.",
      ),
      array(
        'name'   => "day",
        'type'   => Int32,
        'value'  => "INT_MAX",
        'desc'   => "The number of the day.",
      ),
      array(
        'name'   => "year",
        'type'   => Int32,
        'value'  => "INT_MAX",
        'desc'   => "The number of the year, may be a two or four digit value, with values between 0-69 mapping to 2000-2069 and 70-100 to 1970-2000. On systems where time_t is a 32bit signed integer, as most common today, the valid range for year is somewhere between 1901 and 2038. However, before PHP 5.1.0 this range was limited from 1970 to 2038 on some systems (e.g. Windows).",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "strftime",
    'desc'   => "Format the time and/or date according to locale settings. Month and weekday names and other language-dependent strings respect the current locale set with setlocale().\n\nNot all conversion specifiers may be supported by your C library, in which case they will not be supported by PHP's strftime(). Additionally, not all platforms support negative timestamps, so your date range may be limited to no earlier than the Unix epoch. This means that %e, %T, %R and, %D (and possibly others) - as well as dates prior to Jan 1, 1970 - will not work on Windows, some Linux distributions, and a few other operating systems. For Windows systems, a complete overview of supported conversion specifiers can be found at  MSDN.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns a string formatted according format using the given timestamp or the current local time if no timestamp is given. Month and weekday names and other language-dependent strings respect the current locale set with setlocale().",
    ),
    'args'   => array(
      array(
        'name'   => "format",
        'type'   => String,
      ),
      array(
        'name'   => "timestamp",
        'type'   => Int64,
        'value'  => "TimeStamp::Current()",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "strptime",
    'desc'   => "strptime() returns an array with the date parsed, or FALSE on error.\n\nMonth and weekday names and other language dependent strings respect the current locale set with setlocale() (LC_TIME).",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an array or FALSE on failure.\n\nThe following parameters are returned in the array parameters Description \"tm_sec\" Seconds after the minute (0-61) \"tm_min\" Minutes after the hour (0-59) \"tm_hour\" Hour since midnight (0-23) \"tm_mday\" Day of the month (1-31) \"tm_mon\" Months since January (0-11) \"tm_year\" Years since 1900 \"tm_wday\" Days since Sunday (0-6) \"tm_yday\" Days since January 1 (0-365) \"unparsed\" the date part which was not recognized using the specified format",
    ),
    'args'   => array(
      array(
        'name'   => "date",
        'type'   => String,
        'desc'   => "The string to parse (e.g. returned from strftime()).",
      ),
      array(
        'name'   => "format",
        'type'   => String,
        'desc'   => "The format used in date (e.g. the same as used in strftime()). Note that some of the format options available to strftime() may not have any effect within strptime(); the exact subset that are supported will vary based on the operating system and C library in use.\n\nFor more information about the format options, read the strftime() page.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "strtotime",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns a timestamp on success, FALSE otherwise. Previous to PHP 5.1.0, this function would return -1 on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "input",
        'type'   => String,
        'desc'   => "Date and Time Formats.",
      ),
      array(
        'name'   => "timestamp",
        'type'   => Int64,
        'value'  => "TimeStamp::Current()",
        'desc'   => "The timestamp which is used as a base for the calculation of relative dates.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "time",
    'desc'   => "Returns the current time measured in the number of seconds since the Unix Epoch (January 1 1970 00:00:00 GMT).",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int32,
    ),
  ));

DefineFunction(
  array(
    'name'   => "timezone_abbreviations_list",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => StringVec,
    ),
  ));

DefineFunction(
  array(
    'name'   => "timezone_identifiers_list",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => StringVec,
    ),
  ));

DefineFunction(
  array(
    'name'   => "timezone_name_from_abbr",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns time zone name on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "abbr",
        'type'   => String,
        'desc'   => "Time zone abbreviation.",
      ),
      array(
        'name'   => "gmtoffset",
        'type'   => Int32,
        'value'  => "-1",
        'desc'   => "Offset from GMT in seconds. Defaults to -1 which means that first found time zone corresponding to abbr is returned. Otherwise exact offset is searched and only if not found then the first time zone with any offset is returned.",
      ),
      array(
        'name'   => "isdst",
        'type'   => Boolean,
        'value'  => "true",
        'desc'   => "Daylight saving time indicator. Defaults to -1, which means that whether the time zone has daylight saving or not is not taken into consideration when searching. If this is set to 1, then the gmtOffset is assumed to be an offset with daylight saving in effect; if 0, then gmtOffset is assumed to be an offset without daylight saving in effect. If abbr doesn't exist then the time zone is searched solely by the gmtOffset and isdst.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "timezone_name_get",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
    ),
    'args'   => array(
      array(
        'name'   => "object",
        'type'   => Object,
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "timezone_offset_get",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int32,
    ),
    'args'   => array(
      array(
        'name'   => "object",
        'type'   => Object,
      ),
      array(
        'name'   => "dt",
        'type'   => Object,
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "timezone_open",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Object,
    ),
    'args'   => array(
      array(
        'name'   => "timezone",
        'type'   => String,
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "timezone_transitions_get",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => VariantVec,
    ),
    'args'   => array(
      array(
        'name'   => "object",
        'type'   => Object,
      ),
    ),
  ));


///////////////////////////////////////////////////////////////////////////////
// Classes
//
// BeginClass
// array (
//   'name'   => name of the class
//   'desc'   => description of the class's purpose
//   'flags'  => attributes of the class, see base.php for possible values
//   'note'   => additional note about this class's schema
//   'parent' => parent class name, if any
//   'ifaces' => array of interfaces tihs class implements
//   'bases'  => extra internal and special base classes this class requires
//   'footer' => extra C++ inserted at end of class declaration
// )
//
// DefineConstant(..)
// DefineConstant(..)
// ...
// DefineFunction(..)
// DefineFunction(..)
// ...
// DefineProperty
// DefineProperty
//
// array (
//   'name'  => name of the property
//   'type'  => type of the property
//   'flags' => attributes of the property
//   'desc'  => description of the property
//   'note'  => additional note about this property's schema
// )
//
// EndClass()

///////////////////////////////////////////////////////////////////////////////

BeginClass(
  array(
    'name'   => "DateTime",
    'desc'   => "Representation of date and time.",
    'flags'  =>  HasDocComment,
    'footer' => <<<EOT

 private:
  SmartObject<DateTime> m_dt;
 public:
  virtual ObjectData *clone();
EOT
,
  ));

DefineConstant(
  array(
    'name'   => "ATOM",
    'type'   => String,
  ));

DefineConstant(
  array(
    'name'   => "COOKIE",
    'type'   => String,
  ));

DefineConstant(
  array(
    'name'   => "ISO8601",
    'type'   => String,
  ));

DefineConstant(
  array(
    'name'   => "RFC822",
    'type'   => String,
  ));

DefineConstant(
  array(
    'name'   => "RFC850",
    'type'   => String,
  ));

DefineConstant(
  array(
    'name'   => "RFC1036",
    'type'   => String,
  ));

DefineConstant(
  array(
    'name'   => "RFC1123",
    'type'   => String,
  ));

DefineConstant(
  array(
    'name'   => "RFC2822",
    'type'   => String,
  ));

DefineConstant(
  array(
    'name'   => "RFC3339",
    'type'   => String,
  ));

DefineConstant(
  array(
    'name'   => "RSS",
    'type'   => String,
  ));

DefineConstant(
  array(
    'name'   => "W3C",
    'type'   => String,
  ));

DefineFunction(
  array(
    'name'   => "__construct",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => null,
    ),
    'args'   => array(
      array(
        'name'   => "time",
        'type'   => String,
        'value'  => "\"now\"",
      ),
      array(
        'name'   => "timezone",
        'type'   => Object,
        'value'  => "null_object",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "format",
    'desc'   => "Procedural style string date_format ( DateTime \$object , string \$format ) Returns date formatted according to given format.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "Returns the formatted date string on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "format",
        'type'   => String,
        'desc'   => "DateTime object returned by date_create()",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "getOffset",
    'desc'   => "Procedural style int date_offset_get ( DateTime \$object ) Returns the timezone offset.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int64,
      'desc'   => "Returns the timezone offset in seconds from UTC on success or FALSE on failure.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "getTimezone",
    'desc'   => "Procedural style DateTimeZone date_timezone_get ( DateTime \$object ) Return time zone relative to given DateTime.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns a DateTimeZone object on success or FALSE on failure.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "modify",
    'desc'   => "Procedural style DateTime date_modify ( DateTime \$object , string \$modify ) Alter the timestamp of a DateTime object by incrementing or decrementing in a format accepted by strtotime().",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Object,
      'desc'   => "Returns the modified DateTime object or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "modify",
        'type'   => String,
        'desc'   => "DateTime object returned by date_create(). The function modifies this object.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "setDate",
    'desc'   => "Procedural style DateTime date_date_set ( DateTime \$object , int \$year , int \$month , int \$day ) Resets the current date of the DateTime object to a different date.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Object,
      'desc'   => "Returns the modified DateTime object or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "year",
        'type'   => Int64,
        'desc'   => "DateTime object returned by date_create(). The function modifies this object.",
      ),
      array(
        'name'   => "month",
        'type'   => Int64,
        'desc'   => "Year of the date.",
      ),
      array(
        'name'   => "day",
        'type'   => Int64,
        'desc'   => "Month of the date.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "setISODate",
    'desc'   => "Procedural style DateTime date_isodate_set ( DateTime \$object , int \$year , int \$week [, int \$day = 1 ] ) Set a date according to the ISO 8601 standard - using weeks and day offsets rather than specific dates.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Object,
      'desc'   => "Returns the modified DateTime object or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "year",
        'type'   => Int64,
        'desc'   => "DateTime object returned by date_create(). The function modifies this object.",
      ),
      array(
        'name'   => "week",
        'type'   => Int64,
        'desc'   => "Year of the date.",
      ),
      array(
        'name'   => "day",
        'type'   => Int64,
        'value'  => "1",
        'desc'   => "Week of the date.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "setTime",
    'desc'   => "Procedural style DateTime date_time_set ( DateTime \$object , int \$hour , int \$minute [, int \$second = 0 ] ) Resets the current time of the DateTime object to a different time.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Object,
      'desc'   => "Returns the modified DateTime object or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "hour",
        'type'   => Int64,
        'desc'   => "DateTime object returned by date_create(). The function modifies this object.",
      ),
      array(
        'name'   => "minute",
        'type'   => Int64,
        'desc'   => "Hour of the time.",
      ),
      array(
        'name'   => "second",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "Minute of the time.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "setTimezone",
    'desc'   => "Procedural style DateTime date_timezone_set ( DateTime \$object , DateTimeZone \$timezone )",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Object,
      'desc'   => "Returns the modified DateTime object or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "timezone",
        'type'   => Object,
        'desc'   => "DateTime object returned by date_create(). The function modifies this object.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "__destruct",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
    ),
  ));

EndClass(
);

///////////////////////////////////////////////////////////////////////////////

BeginClass(
  array(
    'name'   => "DateTimeZone",
    'desc'   => "Representation of time zone.",
    'flags'  =>  HasDocComment,
    'footer' => <<<EOT

 private:
  SmartObject<TimeZone> m_tz;
 public:
  virtual ObjectData *clone();
EOT
,
  ));

DefineConstant(
  array(
    'name'   => "AFRICA",
    'type'   => Int64,
  ));

DefineConstant(
  array(
    'name'   => "AMERICA",
    'type'   => Int64,
  ));

DefineConstant(
  array(
    'name'   => "ANTARCTICA",
    'type'   => Int64,
  ));

DefineConstant(
  array(
    'name'   => "ARCTIC",
    'type'   => Int64,
  ));

DefineConstant(
  array(
    'name'   => "ASIA",
    'type'   => Int64,
  ));

DefineConstant(
  array(
    'name'   => "ATLANTIC",
    'type'   => Int64,
  ));

DefineConstant(
  array(
    'name'   => "AUSTRALIA",
    'type'   => Int64,
  ));

DefineConstant(
  array(
    'name'   => "EUROPE",
    'type'   => Int64,
  ));

DefineConstant(
  array(
    'name'   => "INDIAN",
    'type'   => Int64,
  ));

DefineConstant(
  array(
    'name'   => "PACIFIC",
    'type'   => Int64,
  ));

DefineConstant(
  array(
    'name'   => "UTC",
    'type'   => Int64,
  ));

DefineConstant(
  array(
    'name'   => "ALL",
    'type'   => Int64,
  ));

DefineConstant(
  array(
    'name'   => "ALL_WITH_BC",
    'type'   => Int64,
  ));

DefineConstant(
  array(
    'name'   => "PER_COUNTRY",
    'type'   => Int64,
  ));

DefineFunction(
  array(
    'name'   => "__construct",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => null,
    ),
    'args'   => array(
      array(
        'name'   => "timezone",
        'type'   => String,
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "getName",
    'desc'   => "Procedural style string timezone_name_get ( void ) Returns the name of the timezone.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "One of timezones.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "getOffset",
    'desc'   => "Procedural style int timezone_offset_get ( DateTimeZone \$object , DateTime \$datetime ) This function returns the offset to GMT for the date/time specified in the datetime parameter. The GMT offset is calculated with the timezone information contained in the DateTimeZone object being used.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int64,
      'desc'   => "Returns time zone offset in seconds on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "datetime",
        'type'   => Object,
        'desc'   => "DateTimeZone object returned by timezone_open()",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "getTransitions",
    'desc'   => "Procedural style array timezone_transitions_get ( DateTimeZone \$object [, int \$timestamp_begin [, int \$timestamp_end ]] )",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => VariantMap,
      'desc'   => "Returns numerically indexed array containing associative array with all transitions on success or FALSE on failure.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "listAbbreviations",
    'desc'   => "Procedural style array timezone_abbreviations_list ( void )",
    'flags'  =>  IsStatic | HasDocComment,
    'return' => array(
      'type'   => VariantMap,
      'desc'   => "Returns array on success or FALSE on failure.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "listIdentifiers",
    'desc'   => "Procedural style array timezone_identifiers_list ([ int \$what = DateTimeZone::ALL [, string \$country = NULL ]] )",
    'flags'  =>  IsStatic | HasDocComment,
    'return' => array(
      'type'   => VariantMap,
      'desc'   => "Returns array on success or FALSE on failure.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "__destruct",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
    ),
  ));

EndClass(
);

