<?php
/**
 * Automatically generated by running "php schema.php mcrypt".
 *
 * You may modify the file, but re-running schema.php against this file will
 * standardize the format without losing your schema changes. It does lose
 * any changes that are not part of schema. Use "note" field to comment on
 * schema itself, and "note" fields are not used in any code generation but
 * only staying within this file.
 */
///////////////////////////////////////////////////////////////////////////////
// Preamble: C++ code inserted at beginning of ext_{name}.h

DefinePreamble(<<<CPP

CPP
);

///////////////////////////////////////////////////////////////////////////////
// Constants
//
// array (
//   'name' => name of the constant
//   'type' => type of the constant
//   'note' => additional note about this constant's schema
// )


///////////////////////////////////////////////////////////////////////////////
// Functions
//
// array (
//   'name'   => name of the function
//   'desc'   => description of the function's purpose
//   'flags'  => attributes of the function, see base.php for possible values
//   'opt'    => optimization callback function's name for compiler
//   'note'   => additional note about this function's schema
//   'return' =>
//      array (
//        'type'  => return type, use Reference for ref return
//        'desc'  => description of the return value
//      )
//   'args'   => arguments
//      array (
//        'name'  => name of the argument
//        'type'  => type of the argument, use Reference for output parameter
//        'value' => default value of the argument
//        'desc'  => description of the argument
//      )
// )

DefineFunction(
  array(
    'name'   => "mcrypt_module_open",
    'desc'   => "This function opens the module of the algorithm and the mode to be used. The name of the algorithm is specified in algorithm, e.g. \"twofish\" or is one of the MCRYPT_ciphername constants. The module is closed by calling mcrypt_module_close().",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Normally it returns an encryption descriptor, or FALSE on error.",
    ),
    'args'   => array(
      array(
        'name'   => "algorithm",
        'type'   => String,
        'desc'   => "The algorithm to be used.",
      ),
      array(
        'name'   => "algorithm_directory",
        'type'   => String,
        'desc'   => "The algorithm_directory and mode_directory are used to locate the encryption modules. When you supply a directory name, it is used. When you set one of these to the empty string (\"\"), the value set by the mcrypt.algorithms_dir or mcrypt.modes_dir ini-directive is used. When these are not set, the default directories that are used are the ones that were compiled in into libmcrypt (usually /usr/local/lib/libmcrypt).",
      ),
      array(
        'name'   => "mode",
        'type'   => String,
        'desc'   => "The mode to be used.",
      ),
      array(
        'name'   => "mode_directory",
        'type'   => String,
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_module_close",
    'desc'   => "Closes the specified encryption handle.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "td",
        'type'   => Resource,
        'desc'   => "The encryption descriptor.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_list_algorithms",
    'desc'   => "Gets the list of all supported algorithms in the lib_dir parameter.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => StringVec,
      'desc'   => "Returns an array with all the supported algorithms.",
    ),
    'args'   => array(
      array(
        'name'   => "lib_dir",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "Specifies the directory where all algorithms are located. If not specifies, the value of the mcrypt.algorithms_dir php.ini directive is used.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_list_modes",
    'desc'   => "Gets the list of all supported modes in the lib_dir parameter.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => StringVec,
      'desc'   => "Returns an array with all the supported modes.",
    ),
    'args'   => array(
      array(
        'name'   => "lib_dir",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "Specifies the directory where all modes are located. If not specifies, the value of the mcrypt.modes_dir php.ini directive is used.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_module_get_algo_block_size",
    'desc'   => "Gets the blocksize of the specified algorithm.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int32,
      'desc'   => "Returns the block size of the algorithm specified in bytes.",
    ),
    'args'   => array(
      array(
        'name'   => "algorithm",
        'type'   => String,
        'desc'   => "The algorithm name.",
      ),
      array(
        'name'   => "lib_dir",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "This optional parameter can contain the location where the mode module is on the system.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_module_get_algo_key_size",
    'desc'   => "Gets the maximum supported keysize of the opened mode.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int32,
      'desc'   => "This function returns the maximum supported key size of the algorithm specified in bytes.",
    ),
    'args'   => array(
      array(
        'name'   => "algorithm",
        'type'   => String,
        'desc'   => "The algorithm name.",
      ),
      array(
        'name'   => "lib_dir",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "This optional parameter can contain the location where the mode module is on the system.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_module_get_supported_key_sizes",
    'desc'   => "Returns an array with the key sizes supported by the specified algorithm. If it returns an empty array then all key sizes between 1 and mcrypt_module_get_algo_key_size() are supported by the algorithm.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int64Vec,
      'desc'   => "Returns an array with the key sizes supported by the specified algorithm. If it returns an empty array then all key sizes between 1 and mcrypt_module_get_algo_key_size() are supported by the algorithm.",
    ),
    'args'   => array(
      array(
        'name'   => "algorithm",
        'type'   => String,
        'desc'   => "The algorithm to used.",
      ),
      array(
        'name'   => "lib_dir",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "The optional lib_dir parameter can contain the location of where the algorithm module is on the system.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_module_is_block_algorithm_mode",
    'desc'   => "This function returns TRUE if the mode is for use with block algorithms, otherwise it returns FALSE. (e.g. FALSE for stream, and TRUE for cbc, cfb, ofb).",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "This function returns TRUE if the mode is for use with block algorithms, otherwise it returns FALSE. (e.g. FALSE for stream, and TRUE for cbc, cfb, ofb).",
    ),
    'args'   => array(
      array(
        'name'   => "mode",
        'type'   => String,
        'desc'   => "The mode to check.",
      ),
      array(
        'name'   => "lib_dir",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "The optional lib_dir parameter can contain the location of where the algorithm module is on the system.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_module_is_block_algorithm",
    'desc'   => "This function returns TRUE if the specified algorithm is a block algorithm, or FALSE is it is a stream algorithm.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "This function returns TRUE if the specified algorithm is a block algorithm, or FALSE is it is a stream algorithm.",
    ),
    'args'   => array(
      array(
        'name'   => "algorithm",
        'type'   => String,
        'desc'   => "The algorithm to check.",
      ),
      array(
        'name'   => "lib_dir",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "The optional lib_dir parameter can contain the location of where the algorithm module is on the system.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_module_is_block_mode",
    'desc'   => "This function returns TRUE if the mode outputs blocks of bytes or FALSE if it outputs just bytes. (e.g. TRUE for cbc and ecb, and FALSE for cfb and stream).",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "This function returns TRUE if the mode outputs blocks of bytes or FALSE if it outputs just bytes. (e.g. TRUE for cbc and ecb, and FALSE for cfb and stream).",
    ),
    'args'   => array(
      array(
        'name'   => "mode",
        'type'   => String,
        'desc'   => "The mode to check.",
      ),
      array(
        'name'   => "lib_dir",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "The optional lib_dir parameter can contain the location of where the algorithm module is on the system.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_module_self_test",
    'desc'   => "This function runs the self test on the algorithm specified.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "The function returns TRUE if the self test succeeds, or FALSE when if fails.",
    ),
    'args'   => array(
      array(
        'name'   => "algorithm",
        'type'   => String,
        'desc'   => "The algorithm to test.",
      ),
      array(
        'name'   => "lib_dir",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "The optional lib_dir parameter can contain the location of where the algorithm module is on the system.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_create_iv",
    'desc'   => "Create an initialization vector (IV) from a random source.\n\nThe IV is only meant to give an alternative seed to the encryption routines. This IV does not need to be secret at all, though it can be desirable. You even can send it along with your ciphertext without losing security.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the initialization vector, or FALSE on error.",
    ),
    'args'   => array(
      array(
        'name'   => "size",
        'type'   => Int32,
        'desc'   => "Determines the size of the IV, parameter source (defaults to random value) specifies the source of the IV.",
      ),
      array(
        'name'   => "source",
        'type'   => Int32,
        'value'  => "0",
        'desc'   => "The source can be MCRYPT_RAND (system random number generator), MCRYPT_DEV_RANDOM (read data from /dev/random) and MCRYPT_DEV_URANDOM (read data from /dev/urandom). Prior to 5.3.0, MCRYPT_RAND was the only one supported on Windows.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_encrypt",
    'desc'   => "Encrypts the data and returns it.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the encrypted data, as a string.",
    ),
    'args'   => array(
      array(
        'name'   => "cipher",
        'type'   => String,
        'desc'   => "One of the MCRYPT_ciphername constants of the name of the algorithm as string.",
      ),
      array(
        'name'   => "key",
        'type'   => String,
        'desc'   => "The key with which the data will be encrypted. If it's smaller that the required keysize, it is padded with '\\0'. It is better not to use ASCII strings for keys.\n\nIt is recommended to use the mhash functions to create a key from a string.",
      ),
      array(
        'name'   => "data",
        'type'   => String,
        'desc'   => "The data that will be encrypted with the given cipher and mode. If the size of the data is not n * blocksize, the data will be padded with '\\0'.\n\nThe returned crypttext can be larger that the size of the data that is given by data.",
      ),
      array(
        'name'   => "mode",
        'type'   => String,
        'desc'   => "One of the MCRYPT_MODE_modename constants of one of \"ecb\", \"cbc\", \"cfb\", \"ofb\", \"nofb\" or \"stream\".",
      ),
      array(
        'name'   => "iv",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "Used for the initialisation in CBC, CFB, OFB modes, and in some algorithms in STREAM mode. If you do not supply an IV, while it is needed for an algorithm, the function issues a warning and uses an IV with all bytes set to '\\0'.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_decrypt",
    'desc'   => "Decrypts the data and returns the unencrypted data.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the decrypted data as a string.",
    ),
    'args'   => array(
      array(
        'name'   => "cipher",
        'type'   => String,
        'desc'   => "cipher is one of the MCRYPT_ciphername constants of the name of the algorithm as string.",
      ),
      array(
        'name'   => "key",
        'type'   => String,
        'desc'   => "key is the key with which the data is encrypted. If it's smaller that the required keysize, it is padded with '\\0'.",
      ),
      array(
        'name'   => "data",
        'type'   => String,
        'desc'   => "data is the data that will be decrypted with the given cipher and mode. If the size of the data is not n * blocksize, the data will be padded with '\\0'.",
      ),
      array(
        'name'   => "mode",
        'type'   => String,
        'desc'   => "mode is one of the MCRYPT_MODE_modename constants of one of \"ecb\", \"cbc\", \"cfb\", \"ofb\", \"nofb\" or \"stream\".",
      ),
      array(
        'name'   => "iv",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "The iv parameter is used for the initialisation in CBC, CFB, OFB modes, and in some algorithms in STREAM mode. If you do not supply an IV, while it is needed for an algorithm, the function issues a warning and uses an IV with all bytes set to '\\0'.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_cbc",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
    ),
    'args'   => array(
      array(
        'name'   => "cipher",
        'type'   => String,
      ),
      array(
        'name'   => "key",
        'type'   => String,
      ),
      array(
        'name'   => "data",
        'type'   => String,
      ),
      array(
        'name'   => "mode",
        'type'   => Int32,
      ),
      array(
        'name'   => "iv",
        'type'   => String,
        'value'  => "null_string",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_cfb",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
    ),
    'args'   => array(
      array(
        'name'   => "cipher",
        'type'   => String,
      ),
      array(
        'name'   => "key",
        'type'   => String,
      ),
      array(
        'name'   => "data",
        'type'   => String,
      ),
      array(
        'name'   => "mode",
        'type'   => Int32,
      ),
      array(
        'name'   => "iv",
        'type'   => String,
        'value'  => "null_string",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_ecb",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
    ),
    'args'   => array(
      array(
        'name'   => "cipher",
        'type'   => String,
      ),
      array(
        'name'   => "key",
        'type'   => String,
      ),
      array(
        'name'   => "data",
        'type'   => String,
      ),
      array(
        'name'   => "mode",
        'type'   => Int32,
      ),
      array(
        'name'   => "iv",
        'type'   => String,
        'value'  => "null_string",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_ofb",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
    ),
    'args'   => array(
      array(
        'name'   => "cipher",
        'type'   => String,
      ),
      array(
        'name'   => "key",
        'type'   => String,
      ),
      array(
        'name'   => "data",
        'type'   => String,
      ),
      array(
        'name'   => "mode",
        'type'   => Int32,
      ),
      array(
        'name'   => "iv",
        'type'   => String,
        'value'  => "null_string",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_get_block_size",
    'desc'   => "The first prototype is when linked against libmcrypt 2.2.x, the second when linked against libmcrypt 2.4.x or 2.5.x.\n\nmcrypt_get_block_size() is used to get the size of a block of the specified cipher (in combination with an encryption mode).\n\nIt is more useful to use the mcrypt_enc_get_block_size() function as this uses the resource returned by mcrypt_module_open().",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Gets the block size, as an integer.",
    ),
    'args'   => array(
      array(
        'name'   => "cipher",
        'type'   => String,
        'desc'   => "One of the MCRYPT_ciphername constants or the name of the algorithm as string.",
      ),
      array(
        'name'   => "module",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "The module.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_get_cipher_name",
    'desc'   => "mcrypt_get_cipher_name() is used to get the name of the specified cipher.\n\nmcrypt_get_cipher_name() takes the cipher number as an argument (libmcrypt 2.2.x) or takes the cipher name as an argument (libmcrypt 2.4.x or higher) and returns the name of the cipher or FALSE, if the cipher does not exist.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "This function returns the name of the cipher or FALSE, if the cipher does not exist.",
    ),
    'args'   => array(
      array(
        'name'   => "cipher",
        'type'   => String,
        'desc'   => "One of the MCRYPT_ciphername constants or the name of the algorithm as string.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_get_iv_size",
    'desc'   => "Gets the size of the IV belonging to a specific cipher/mode combination.\n\nIt is more useful to use the mcrypt_enc_get_iv_size() function as this uses the resource returned by mcrypt_module_open().",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the size of the Initialisation Vector (IV) in bytes. On error the function returns FALSE. If the IV is ignored in the specified cipher/mode combination zero is returned.",
    ),
    'args'   => array(
      array(
        'name'   => "cipher",
        'type'   => String,
        'desc'   => "One of the MCRYPT_ciphername constants of the name of the algorithm as string.",
      ),
      array(
        'name'   => "mode",
        'type'   => String,
        'desc'   => "mode is one of the MCRYPT_MODE_modename constants or one of \"ecb\", \"cbc\", \"cfb\", \"ofb\", \"nofb\" or \"stream\". The IV is ignored in ECB mode as this mode does not require it. You will need to have the same IV (think: starting point) both at encryption and decryption stages, otherwise your encryption will fail.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_get_key_size",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int32,
    ),
    'args'   => array(
      array(
        'name'   => "cipher",
        'type'   => String,
      ),
      array(
        'name'   => "module",
        'type'   => String,
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_enc_get_algorithms_name",
    'desc'   => "This function returns the name of the algorithm.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "Returns the name of the opened algorithm as a string.",
    ),
    'args'   => array(
      array(
        'name'   => "td",
        'type'   => Resource,
        'desc'   => "The encryption descriptor.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_enc_get_block_size",
    'desc'   => "Gets the blocksize of the opened algorithm.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int32,
      'desc'   => "Returns the block size of the specified algorithm in bytes.",
    ),
    'args'   => array(
      array(
        'name'   => "td",
        'type'   => Resource,
        'desc'   => "The encryption descriptor.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_enc_get_iv_size",
    'desc'   => "This function returns the size of the IV of the algorithm specified by the encryption descriptor in bytes. An IV is used in cbc, cfb and ofb modes, and in some algorithms in stream mode.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int32,
      'desc'   => "Returns the size of the IV, or 0 if the IV is ignored in the algorithm.",
    ),
    'args'   => array(
      array(
        'name'   => "td",
        'type'   => Resource,
        'desc'   => "The encryption descriptor.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_enc_get_key_size",
    'desc'   => "Gets the maximum supported key size of the algorithm in bytes.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int32,
      'desc'   => "Returns the maximum supported key size of the algorithm in bytes.",
    ),
    'args'   => array(
      array(
        'name'   => "td",
        'type'   => Resource,
        'desc'   => "The encryption descriptor.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_enc_get_modes_name",
    'desc'   => "This function returns the name of the mode.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "Returns the name as a string.",
    ),
    'args'   => array(
      array(
        'name'   => "td",
        'type'   => Resource,
        'desc'   => "The encryption descriptor.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_enc_get_supported_key_sizes",
    'desc'   => "Gets the supported key sizes of the opened algorithm.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int64Vec,
      'desc'   => "Returns an array with the key sizes supported by the algorithm specified by the encryption descriptor. If it returns an empty array then all key sizes between 1 and mcrypt_enc_get_key_size() are supported by the algorithm.",
    ),
    'args'   => array(
      array(
        'name'   => "td",
        'type'   => Resource,
        'desc'   => "The encryption descriptor.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_enc_is_block_algorithm_mode",
    'desc'   => "Tells whether the algorithm of the opened mode works on blocks (e.g. FALSE for stream, and TRUE for cbc, cfb, ofb)..",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE if the mode is for use with block algorithms, otherwise it returns FALSE.",
    ),
    'args'   => array(
      array(
        'name'   => "td",
        'type'   => Resource,
        'desc'   => "The encryption descriptor.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_enc_is_block_algorithm",
    'desc'   => "Tells whether the algorithm of the opened mode is a block algorithm.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE if the algorithm is a block algorithm or FALSE if it is a stream one.",
    ),
    'args'   => array(
      array(
        'name'   => "td",
        'type'   => Resource,
        'desc'   => "The encryption descriptor.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_enc_is_block_mode",
    'desc'   => "Tells whether the opened mode outputs blocks (e.g. TRUE for cbc and ecb, and FALSE for cfb and stream).",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE if the mode outputs blocks of bytes or FALSE if it outputs bytes.",
    ),
    'args'   => array(
      array(
        'name'   => "td",
        'type'   => Resource,
        'desc'   => "The encryption descriptor.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_enc_self_test",
    'desc'   => "This function runs the self test on the algorithm specified by the descriptor td.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int32,
      'desc'   => "If the self test succeeds it returns FALSE. In case of an error, it returns TRUE.",
    ),
    'args'   => array(
      array(
        'name'   => "td",
        'type'   => Resource,
        'desc'   => "The encryption descriptor.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_generic",
    'desc'   => "This function encrypts data. The data is padded with \"\\0\" to make sure the length of the data is n * blocksize. This function returns the encrypted data. Note that the length of the returned string can in fact be longer then the input, due to the padding of the data.\n\nIf you want to store the encrypted data in a database make sure to store the entire string as returned by mcrypt_generic, or the string will not entirely decrypt properly. If your original string is 10 characters long and the block size is 8 (use mcrypt_enc_get_block_size() to determine the blocksize), you would need at least 16 characters in your database field. Note the string returned by mdecrypt_generic() will be 16 characters as well...use rtrim(\$str, \"\\0\") to remove the padding.\n\nIf you are for example storing the data in a MySQL database remember that varchar fields automatically have trailing spaces removed during insertion. As encrypted data can end in a space (ASCII 32), the data will be damaged by this removal. Store data in a tinyblob/tinytext (or larger) field instead.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the encrypted data.",
    ),
    'args'   => array(
      array(
        'name'   => "td",
        'type'   => Resource,
        'desc'   => "The encryption descriptor.\n\nThe encryption handle should always be initialized with mcrypt_generic_init() with a key and an IV before calling this function. Where the encryption is done, you should free the encryption buffers by calling mcrypt_generic_deinit(). See mcrypt_module_open() for an example.",
      ),
      array(
        'name'   => "data",
        'type'   => String,
        'desc'   => "The data to encrypt.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_generic_init",
    'desc'   => "You need to call this function before every call to mcrypt_generic() or mdecrypt_generic().",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int32,
      'desc'   => "The function returns a negative value on error, -3 when the key length was incorrect, -4 when there was a memory allocation problem and any other return value is an unknown error. If an error occurs a warning will be displayed accordingly. FALSE is returned if incorrect parameters were passed.",
    ),
    'args'   => array(
      array(
        'name'   => "td",
        'type'   => Resource,
        'desc'   => "The encryption descriptor.",
      ),
      array(
        'name'   => "key",
        'type'   => String,
        'desc'   => "The maximum length of the key should be the one obtained by calling mcrypt_enc_get_key_size() and every value smaller than this is legal.",
      ),
      array(
        'name'   => "iv",
        'type'   => String,
        'desc'   => "The IV should normally have the size of the algorithms block size, but you must obtain the size by calling mcrypt_enc_get_iv_size(). IV is ignored in ECB. IV MUST exist in CFB, CBC, STREAM, nOFB and OFB modes. It needs to be random and unique (but not secret). The same IV must be used for encryption/decryption. If you do not want to use it you should set it to zeros, but this is not recommended.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mdecrypt_generic",
    'desc'   => "This function decrypts data. Note that the length of the returned string can in fact be longer then the unencrypted string, due to the padding of the data.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
    ),
    'args'   => array(
      array(
        'name'   => "td",
        'type'   => Resource,
        'desc'   => "An encryption descriptor returned by mcrypt_module_open()",
      ),
      array(
        'name'   => "data",
        'type'   => String,
        'desc'   => "Encrypted data.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_generic_deinit",
    'desc'   => "This function terminates encryption specified by the encryption descriptor (td). It clears all buffers, but does not close the module. You need to call mcrypt_module_close() yourself. (But PHP does this for you at the end of the script.)",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "td",
        'type'   => Resource,
        'desc'   => "The encryption descriptor.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "mcrypt_generic_end",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
    ),
    'args'   => array(
      array(
        'name'   => "td",
        'type'   => Resource,
      ),
    ),
  ));


///////////////////////////////////////////////////////////////////////////////
// Classes
//
// BeginClass
// array (
//   'name'   => name of the class
//   'desc'   => description of the class's purpose
//   'flags'  => attributes of the class, see base.php for possible values
//   'note'   => additional note about this class's schema
//   'parent' => parent class name, if any
//   'ifaces' => array of interfaces tihs class implements
//   'bases'  => extra internal and special base classes this class requires
//   'footer' => extra C++ inserted at end of class declaration
// )
//
// DefineConstant(..)
// DefineConstant(..)
// ...
// DefineFunction(..)
// DefineFunction(..)
// ...
// DefineProperty
// DefineProperty
//
// array (
//   'name'  => name of the property
//   'type'  => type of the property
//   'flags' => attributes of the property
//   'desc'  => description of the property
//   'note'  => additional note about this property's schema
// )
//
// EndClass()

