<?php
/**
 * Automatically generated by running "php schema.php network".
 *
 * You may modify the file, but re-running schema.php against this file will
 * standardize the format without losing your schema changes. It does lose
 * any changes that are not part of schema. Use "note" field to comment on
 * schema itself, and "note" fields are not used in any code generation but
 * only staying within this file.
 */
///////////////////////////////////////////////////////////////////////////////
// Preamble: C++ code inserted at beginning of ext_{name}.h

DefinePreamble(<<<CPP

CPP
);

///////////////////////////////////////////////////////////////////////////////
// Constants
//
// array (
//   'name' => name of the constant
//   'type' => type of the constant
//   'note' => additional note about this constant's schema
// )


///////////////////////////////////////////////////////////////////////////////
// Functions
//
// array (
//   'name'   => name of the function
//   'desc'   => description of the function's purpose
//   'flags'  => attributes of the function, see base.php for possible values
//   'opt'    => optimization callback function's name for compiler
//   'note'   => additional note about this function's schema
//   'return' =>
//      array (
//        'type'  => return type, use Reference for ref return
//        'desc'  => description of the return value
//      )
//   'args'   => arguments
//      array (
//        'name'  => name of the argument
//        'type'  => type of the argument, use Reference for output parameter
//        'value' => default value of the argument
//        'desc'  => description of the argument
//      )
// )

DefineFunction(
  array(
    'name'   => "gethostbyaddr",
    'desc'   => "Returns the host name of the Internet host specified by ip_address.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the host name or the unmodified ip_address on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "ip_address",
        'type'   => String,
        'desc'   => "The host IP address.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "gethostbyname",
    'desc'   => "Returns the IPv4 address of the Internet host specified by hostname.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "Returns the IPv4 address or a string containing the unmodified hostname on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "hostname",
        'type'   => String,
        'desc'   => "The host name.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "gethostbynamel",
    'desc'   => "Returns a list of IPv4 addresses to which the Internet host specified by hostname resolves.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns an array of IPv4 addresses or FALSE if hostname could not be resolved.",
    ),
    'args'   => array(
      array(
        'name'   => "hostname",
        'type'   => String,
        'desc'   => "The host name.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "getprotobyname",
    'desc'   => "getprotobyname() returns the protocol number associated with the protocol name as per /etc/protocols.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the protocol number or -1 if the protocol is not found.",
    ),
    'args'   => array(
      array(
        'name'   => "name",
        'type'   => String,
        'desc'   => "The protocol name.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "getprotobynumber",
    'desc'   => "getprotobynumber() returns the protocol name associated with protocol number as per /etc/protocols.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the protocol name as a string, or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "number",
        'type'   => Int32,
        'desc'   => "The protocol number.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "getservbyname",
    'desc'   => "getservbyname() returns the Internet port which corresponds to service for the specified protocol as per /etc/services.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the port number, or FALSE if service or protocol is not found.",
    ),
    'args'   => array(
      array(
        'name'   => "service",
        'type'   => String,
        'desc'   => "The Internet service name, as a string.",
      ),
      array(
        'name'   => "protocol",
        'type'   => String,
        'desc'   => "protocol is either \"tcp\" or \"udp\" (in lowercase).",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "getservbyport",
    'desc'   => "getservbyport() returns the Internet service associated with port for the specified protocol as per /etc/services.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the Internet service name as a string.",
    ),
    'args'   => array(
      array(
        'name'   => "port",
        'type'   => Int32,
        'desc'   => "The port number.",
      ),
      array(
        'name'   => "protocol",
        'type'   => String,
        'desc'   => "protocol is either \"tcp\" or \"udp\" (in lowercase).",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "inet_ntop",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns a string representation of the address or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "in_addr",
        'type'   => String,
        'desc'   => "A 32bit IPv4, or 128bit IPv6 address.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "inet_pton",
    'desc'   => "This function converts a human readable IPv4 or IPv6 address (if PHP was built with IPv6 support enabled) into an address family appropriate 32bit or 128bit binary structure.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the in_addr representation of the given address",
    ),
    'args'   => array(
      array(
        'name'   => "address",
        'type'   => String,
        'desc'   => "A human readable IPv4 or IPv6 address.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "ip2long",
    'desc'   => "The function ip2long() generates an IPv4 Internet network address from its Internet standard format (dotted string) representation.\n\nip2long() will also work with non-complete IP addresses. Read  http://publibn.boulder.ibm.com/doc_link/en_US/a_doc_lib/libs/commtrf2/inet_addr.htm for more info.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the IPv4 address or FALSE if ip_address is invalid.",
    ),
    'args'   => array(
      array(
        'name'   => "ip_address",
        'type'   => String,
        'desc'   => "A standard format address.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "long2ip",
    'desc'   => "The function long2ip() generates an Internet address in dotted format (i.e.: aaa.bbb.ccc.ddd) from the proper address representation.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "Returns the Internet IP address as a string.",
    ),
    'args'   => array(
      array(
        'name'   => "proper_address",
        'type'   => Int32,
        'desc'   => "A proper address representation.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "dns_check_record",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
    ),
    'args'   => array(
      array(
        'name'   => "host",
        'type'   => String,
      ),
      array(
        'name'   => "type",
        'type'   => String,
        'value'  => "null_string",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "checkdnsrr",
    'desc'   => "Searches DNS for records of type type corresponding to host.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE if any records are found; returns FALSE if no records were found or if an error occurred.",
    ),
    'args'   => array(
      array(
        'name'   => "host",
        'type'   => String,
        'desc'   => "host may either be the IP address in dotted-quad notation or the host name.",
      ),
      array(
        'name'   => "type",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "type may be any one of: A, MX, NS, SOA, PTR, CNAME, AAAA, A6, SRV, NAPTR, TXT or ANY.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "dns_get_record",
    'desc'   => "Fetch DNS Resource Records associated with the given hostname.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
    ),
    'args'   => array(
      array(
        'name'   => "hostname",
        'type'   => String,
        'desc'   => "hostname should be a valid DNS hostname such as \"www.example.com\". Reverse lookups can be generated using in-addr.arpa notation, but gethostbyaddr() is more suitable for the majority of reverse lookups.\n\nPer DNS standards, email addresses are given in user.host format (for example: hostmaster.example.com as opposed to hostmaster@example.com), be sure to check this value and modify if necessary before using it with a functions such as mail().",
      ),
      array(
        'name'   => "type",
        'type'   => Int32,
        'value'  => "-1",
        'desc'   => "By default, dns_get_record() will search for any resource records associated with hostname. To limit the query, specify the optional type parameter. May be any one of the following: DNS_A, DNS_CNAME, DNS_HINFO, DNS_MX, DNS_NS, DNS_PTR, DNS_SOA, DNS_TXT, DNS_AAAA, DNS_SRV, DNS_NAPTR, DNS_A6, DNS_ALL or DNS_ANY.\n\nBecause of eccentricities in the performance of libresolv between platforms, DNS_ANY will not always return every record, the slower DNS_ALL will collect all records more reliably.",
      ),
      array(
        'name'   => "authns",
        'type'   => Variant | Reference,
        'value'  => "null",
        'desc'   => "Passed by reference and, if given, will be populated with Resource Records for the Authoritative Name Servers.",
      ),
      array(
        'name'   => "addtl",
        'type'   => Variant | Reference,
        'value'  => "null",
        'desc'   => "Passed by reference and, if given, will be populated with any Additional Records.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "dns_get_mx",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
    ),
    'args'   => array(
      array(
        'name'   => "hostname",
        'type'   => String,
      ),
      array(
        'name'   => "mxhosts",
        'type'   => Variant | Reference,
      ),
      array(
        'name'   => "weights",
        'type'   => Variant | Reference,
        'value'  => "null",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "getmxrr",
    'desc'   => "Searches DNS for MX records corresponding to hostname.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE if any records are found; returns FALSE if no records were found or if an error occurred.",
    ),
    'args'   => array(
      array(
        'name'   => "hostname",
        'type'   => String,
        'desc'   => "The Internet host name.",
      ),
      array(
        'name'   => "mxhosts",
        'type'   => Variant | Reference,
        'desc'   => "A list of the MX records found is placed into the array mxhosts.",
      ),
      array(
        'name'   => "weight",
        'type'   => Variant | Reference,
        'value'  => "null",
        'desc'   => "If the weight array is given, it will be filled with the weight information gathered.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "fsockopen",
    'desc'   => "Initiates a socket connection to the resource specified by hostname.\n\nPHP supports targets in the Internet and Unix domains as described in List of Supported Socket Transports. A list of supported transports can also be retrieved using stream_get_transports().\n\nThe socket will by default be opened in blocking mode. You can switch it to non-blocking mode by using stream_set_blocking().",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "fsockopen() returns a file pointer which may be used together with the other file functions (such as fgets(), fgetss(), fwrite(), fclose(), and feof()). If the call fails, it will return FALSE",
    ),
    'args'   => array(
      array(
        'name'   => "hostname",
        'type'   => String,
        'desc'   => "If you have compiled in OpenSSL support, you may prefix the hostname with either ssl:// or tls:// to use an SSL or TLS client connection over TCP/IP to connect to the remote host.",
      ),
      array(
        'name'   => "port",
        'type'   => Int32,
        'value'  => "-1",
        'desc'   => "The port number.",
      ),
      array(
        'name'   => "errnum",
        'type'   => Variant | Reference,
        'value'  => "null",
        'desc'   => "If provided, holds the system level error number that occurred in the system-level connect() call.\n\nIf the value returned in errno is 0 and the function returned FALSE, it is an indication that the error occurred before the connect() call. This is most likely due to a problem initializing the socket.",
      ),
      array(
        'name'   => "errstr",
        'type'   => Variant | Reference,
        'value'  => "null",
        'desc'   => "The error message as a string.",
      ),
      array(
        'name'   => "timeout",
        'type'   => Double,
        'value'  => "0.0",
        'desc'   => "The connection timeout, in seconds.\n\nIf you need to set a timeout for reading/writing data over the socket, use stream_set_timeout(), as the timeout parameter to fsockopen() only applies while connecting the socket.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "pfsockopen",
    'desc'   => "This function behaves exactly as fsockopen() with the difference that the connection is not closed after the script finishes. It is the persistent version of fsockopen().\nFor parameter information, see the fsockopen() documentation.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
    ),
    'args'   => array(
      array(
        'name'   => "hostname",
        'type'   => String,
      ),
      array(
        'name'   => "port",
        'type'   => Int32,
        'value'  => "-1",
      ),
      array(
        'name'   => "errnum",
        'type'   => Variant | Reference,
        'value'  => "null",
      ),
      array(
        'name'   => "errstr",
        'type'   => Variant | Reference,
        'value'  => "null",
      ),
      array(
        'name'   => "timeout",
        'type'   => Double,
        'value'  => "0.0",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "socket_get_status",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
    ),
    'args'   => array(
      array(
        'name'   => "stream",
        'type'   => Resource,
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "socket_set_blocking",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
    ),
    'args'   => array(
      array(
        'name'   => "stream",
        'type'   => Resource,
      ),
      array(
        'name'   => "mode",
        'type'   => Int32,
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "socket_set_timeout",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
    ),
    'args'   => array(
      array(
        'name'   => "stream",
        'type'   => Resource,
      ),
      array(
        'name'   => "seconds",
        'type'   => Int32,
      ),
      array(
        'name'   => "microseconds",
        'type'   => Int32,
        'value'  => "0",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "header",
    'desc'   => "header() is used to send a raw HTTP header. See the  HTTP/1.1 specification for more information on HTTP headers.\n\nRemember that header() must be called before any actual output is sent, either by normal HTML tags, blank lines in a file, or from PHP. It is a very common error to read code with include(), or require(), functions, or another file access function, and have spaces or empty lines that are output before header() is called. The same problem exists when using a single PHP/HTML file.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => null,
      'desc'   => "No value is returned.",
    ),
    'args'   => array(
      array(
        'name'   => "str",
        'type'   => String,
        'desc'   => "The header string.\n\nThere are two special-case header calls. The first is a header that starts with the string \"HTTP/\" (case is not significant), which will be used to figure out the HTTP status code to send. For example, if you have configured Apache to use a PHP script to handle requests for missing files (using the ErrorDocument directive), you may want to make sure that your script generates the proper status code.\n\n\n\n\n\nThe second special case is the \"Location:\" header. Not only does it send this header back to the browser, but it also returns a REDIRECT (302) status code to the browser unless the 201 or a 3xx status code has already been set.",
      ),
      array(
        'name'   => "replace",
        'type'   => Boolean,
        'value'  => "true",
        'desc'   => "The optional replace parameter indicates whether the header should replace a previous similar header, or add a second header of the same type. By default it will replace, but if you pass in FALSE as the second argument you can force multiple headers of the same type. For example:",
      ),
      array(
        'name'   => "http_response_code",
        'type'   => Int32,
        'value'  => "0",
        'desc'   => "Forces the HTTP response code to the specified value.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "headers_list",
    'desc'   => "headers_list() will return a list of headers to be sent to the browser / client. To determine whether or not these headers have been sent yet, use headers_sent().",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => StringVec,
      'desc'   => "Returns a numerically indexed array of headers.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "headers_sent",
    'desc'   => "Checks if or where headers have been sent.\n\nYou can't add any more header lines using the header() function once the header block has already been sent. Using this function you can at least prevent getting HTTP header related error messages. Another option is to use Output Buffering.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "headers_sent() will return FALSE if no HTTP headers have already been sent or TRUE otherwise.",
    ),
    'args'   => array(
      array(
        'name'   => "file",
        'type'   => Variant | Reference,
        'value'  => "null",
        'desc'   => "If the optional file and line parameters are set, headers_sent() will put the PHP source file name and line number where output started in the file and line variables.",
      ),
      array(
        'name'   => "line",
        'type'   => Variant | Reference,
        'value'  => "null",
        'desc'   => "The line number where the output started.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "header_remove",
    'desc'   => "Removes an HTTP header previously set using header().",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => null,
      'desc'   => "No value is returned.",
    ),
    'args'   => array(
      array(
        'name'   => "name",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "The header name to be removed. This parameter is case-insensitive.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "setcookie",
    'desc'   => "setcookie() defines a cookie to be sent along with the rest of the HTTP headers. Like other headers, cookies must be sent before any output from your script (this is a protocol restriction). This requires that you place calls to this function prior to any output, including <html> and <head> tags as well as any whitespace.\n\nOnce the cookies have been set, they can be accessed on the next page load with the \$_COOKIE or \$HTTP_COOKIE_VARS arrays. Note, superglobals such as \$_COOKIE became available in PHP 4.1.0. Cookie values also exist in \$_REQUEST.\nAll the arguments except the name argument are optional. You may also replace an argument with an empty string (\"\") in order to skip that argument. Because the expire argument is integer, it cannot be skipped with an empty string, use a zero (0) instead.\n\nSee  Netscape cookie specification for specifics on how each setcookie() parameter works",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "If output exists prior to calling this function, setcookie() will fail and return FALSE. If setcookie() successfully runs, it will return TRUE. This does not indicate whether the user accepted the cookie.",
    ),
    'args'   => array(
      array(
        'name'   => "name",
        'type'   => String,
        'desc'   => "The name of the cookie.",
      ),
      array(
        'name'   => "value",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "The value of the cookie. This value is stored on the clients computer; do not store sensitive information. Assuming the name is 'cookiename', this value is retrieved through \$_COOKIE['cookiename']",
      ),
      array(
        'name'   => "expire",
        'type'   => Int64,
        'value'  => "0",
        'desc'   => "The time the cookie expires. This is a Unix timestamp so is in number of seconds since the epoch. In other words, you'll most likely set this with the time() function plus the number of seconds before you want it to expire. Or you might use mktime(). time()+60*60*24*30 will set the cookie to expire in 30 days. If set to 0, or omitted, the cookie will expire at the end of the session (when the browser closes).\n\n\n\nYou may notice the expire parameter takes on a Unix timestamp, as opposed to the date format Wdy, DD-Mon-YYYY HH:MM:SS GMT, this is because PHP does this conversion internally.\n\nexpire is compared to the client's time which can differ from server's time.",
      ),
      array(
        'name'   => "path",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "The path on the server in which the cookie will be available on. If set to '/', the cookie will be available within the entire domain. If set to '/foo/', the cookie will only be available within the /foo/ directory and all sub-directories such as /foo/bar/ of domain. The default value is the current directory that the cookie is being set in.",
      ),
      array(
        'name'   => "domain",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "The domain that the cookie is available. To make the cookie available on all subdomains of example.com then you'd set it to '.example.com'. The . is not required but makes it compatible with more browsers. Setting it to www.example.com will make the cookie only available in the www subdomain. Refer to tail matching in the  spec for details.",
      ),
      array(
        'name'   => "secure",
        'type'   => Boolean,
        'value'  => "false",
        'desc'   => "Indicates that the cookie should only be transmitted over a secure HTTPS connection from the client. When set to TRUE, the cookie will only be set if a secure connection exists. On the server-side, it's on the programmer to send this kind of cookie only on secure connection (e.g. with respect to \$_SERVER[\"HTTPS\"]).",
      ),
      array(
        'name'   => "httponly",
        'type'   => Boolean,
        'value'  => "false",
        'desc'   => "When TRUE the cookie will be made accessible only through the HTTP protocol. This means that the cookie won't be accessible by scripting languages, such as JavaScript. This setting can effectively help to reduce identity theft through XSS attacks (although it is not supported by all browsers). Added in PHP 5.2.0. TRUE or FALSE",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "setrawcookie",
    'desc'   => "setrawcookie() is exactly the same as setcookie() except that the cookie value will not be automatically urlencoded when sent to the browser.\nFor parameter information, see the setcookie() documentation.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "name",
        'type'   => String,
      ),
      array(
        'name'   => "value",
        'type'   => String,
        'value'  => "null_string",
      ),
      array(
        'name'   => "expire",
        'type'   => Int64,
        'value'  => "0",
      ),
      array(
        'name'   => "path",
        'type'   => String,
        'value'  => "null_string",
      ),
      array(
        'name'   => "domain",
        'type'   => String,
        'value'  => "null_string",
      ),
      array(
        'name'   => "secure",
        'type'   => Boolean,
        'value'  => "false",
      ),
      array(
        'name'   => "httponly",
        'type'   => Boolean,
        'value'  => "false",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "define_syslog_variables",
    'desc'   => "Initializes all variables used in the syslog functions.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => null,
    ),
  ));

DefineFunction(
  array(
    'name'   => "openlog",
    'desc'   => "openlog() opens a connection to the system logger for a program.\n\nThe use of openlog() is optional. It will automatically be called by syslog() if necessary, in which case ident will default to FALSE.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "ident",
        'type'   => String,
        'desc'   => "The string ident is added to each message.",
      ),
      array(
        'name'   => "option",
        'type'   => Int32,
        'desc'   => "The option argument is used to indicate what logging options will be used when generating a log message. openlog() Options Constant Description LOG_CONS if there is an error while sending data to the system logger, write directly to the system console LOG_NDELAY open the connection to the logger immediately LOG_ODELAY (default) delay opening the connection until the first message is logged LOG_PERROR print log message also to standard error LOG_PID include PID with each message You can use one or more of this options. When using multiple options you need to OR them, i.e. to open the connection immediately, write to the console and include the PID in each message, you will use: LOG_CONS | LOG_NDELAY | LOG_PID",
      ),
      array(
        'name'   => "facility",
        'type'   => Int32,
        'desc'   => "The facility argument is used to specify what type of program is logging the message. This allows you to specify (in your machine's syslog configuration) how messages coming from different facilities will be handled. openlog() Facilities Constant Description LOG_AUTH security/authorization messages (use LOG_AUTHPRIV instead in systems where that constant is defined) LOG_AUTHPRIV security/authorization messages (private) LOG_CRON clock daemon (cron and at) LOG_DAEMON other system daemons LOG_KERN kernel messages LOG_LOCAL0 ... LOG_LOCAL7 reserved for local use, these are not available in Windows LOG_LPR line printer subsystem LOG_MAIL mail subsystem LOG_NEWS USENET news subsystem LOG_SYSLOG messages generated internally by syslogd LOG_USER generic user-level messages LOG_UUCP UUCP subsystem\n\nLOG_USER is the only valid log type under Windows operating systems",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "closelog",
    'desc'   => "closelog() closes the descriptor being used to write to the system logger. The use of closelog() is optional.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "syslog",
    'desc'   => "syslog() generates a log message that will be distributed by the system logger.\n\nFor information on setting up a user defined log handler, see the syslog.conf (5) Unix manual page. More information on the syslog facilities and option can be found in the man pages for syslog (3) on Unix machines.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "priority",
        'type'   => Int32,
        'desc'   => "priority is a combination of the facility and the level. Possible values are: syslog() Priorities (in descending order) Constant Description LOG_EMERG system is unusable LOG_ALERT action must be taken immediately LOG_CRIT critical conditions LOG_ERR error conditions LOG_WARNING warning conditions LOG_NOTICE normal, but significant, condition LOG_INFO informational message LOG_DEBUG debug-level message",
      ),
      array(
        'name'   => "message",
        'type'   => String,
        'desc'   => "The message to send, except that the two characters %m will be replaced by the error message string (strerror) corresponding to the present value of errno.",
      ),
    ),
  ));


///////////////////////////////////////////////////////////////////////////////
// Classes
//
// BeginClass
// array (
//   'name'   => name of the class
//   'desc'   => description of the class's purpose
//   'flags'  => attributes of the class, see base.php for possible values
//   'note'   => additional note about this class's schema
//   'parent' => parent class name, if any
//   'ifaces' => array of interfaces tihs class implements
//   'bases'  => extra internal and special base classes this class requires
//   'footer' => extra C++ inserted at end of class declaration
// )
//
// DefineConstant(..)
// DefineConstant(..)
// ...
// DefineFunction(..)
// DefineFunction(..)
// ...
// DefineProperty
// DefineProperty
//
// array (
//   'name'  => name of the property
//   'type'  => type of the property
//   'flags' => attributes of the property
//   'desc'  => description of the property
//   'note'  => additional note about this property's schema
// )
//
// EndClass()

