<?php
/**
 * Automatically generated by running "php schema.php options".
 *
 * You may modify the file, but re-running schema.php against this file will
 * standardize the format without losing your schema changes. It does lose
 * any changes that are not part of schema. Use "note" field to comment on
 * schema itself, and "note" fields are not used in any code generation but
 * only staying within this file.
 *
 * @nolint
 */
///////////////////////////////////////////////////////////////////////////////
// Preamble: C++ code inserted at beginning of ext_{name}.h

DefinePreamble(<<<CPP

CPP
);

///////////////////////////////////////////////////////////////////////////////
// Constants
//
// array (
//   'name' => name of the constant
//   'type' => type of the constant
//   'note' => additional note about this constant's schema
// )


///////////////////////////////////////////////////////////////////////////////
// Functions
//
// array (
//   'name'   => name of the function
//   'desc'   => description of the function's purpose
//   'flags'  => attributes of the function, see base.php for possible values
//   'opt'    => optimization callback function's name for compiler
//   'note'   => additional note about this function's schema
//   'return' =>
//      array (
//        'type'  => return type, use Reference for ref return
//        'desc'  => description of the return value
//      )
//   'args'   => arguments
//      array (
//        'name'  => name of the argument
//        'type'  => type of the argument, use Reference for output parameter
//        'value' => default value of the argument
//        'desc'  => description of the argument
//      )
// )

DefineFunction(
  array(
    'name'   => "assert_options",
    'desc'   => "Set the various assert() control options or just query their current settings.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the original setting of any option or FALSE on errors.",
    ),
    'args'   => array(
      array(
        'name'   => "what",
        'type'   => Int32,
        'desc'   => "Assert Options Option INI Setting Default value Description ASSERT_ACTIVE assert.active 1 enable assert() evaluation ASSERT_WARNING assert.warning 1 issue a PHP warning for each failed assertion ASSERT_BAIL assert.bail 0 terminate execution on failed assertions ASSERT_QUIET_EVAL assert.quiet_eval 0 disable error_reporting during assertion expression evaluation ASSERT_CALLBACK assert.callback (NULL) Callback to call on failed assertions",
      ),
      array(
        'name'   => "value",
        'type'   => Variant,
        'value'  => "null_variant",
        'desc'   => "An optional new value for the option.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "assert",
    'desc'   => "assert() will check the given assertion and take appropriate action if its result is FALSE.\n\nIf the assertion is given as a string it will be evaluated as PHP code by assert(). The advantages of a string assertion are less overhead when assertion checking is off and messages containing the assertion expression when an assertion fails. This means that if you pass a boolean condition as assertion this condition will not show up as parameter to the assertion function which you may have defined with the assert_options() function, the condition is converted to a string before calling that handler function, and the boolean FALSE is converted as the empty string.\n\nAssertions should be used as a debugging feature only. You may use them for sanity-checks that test for conditions that should always be TRUE and that indicate some programming errors if not or to check for the presence of certain features like extension functions or certain system limits and features.\n\nAssertions should not be used for normal runtime operations like input parameter checks. As a rule of thumb your code should always be able to work correctly if assertion checking is not activated.\n\nThe behavior of assert() may be configured by assert_options() or by .ini-settings described in that functions manual page.\n\nThe assert_options() function and/or ASSERT_CALLBACK configuration directive allow a callback function to be set to handle failed assertions.\n\nassert() callbacks are particularly useful for building automated test suites because they allow you to easily capture the code passed to the assertion, along with information on where the assertion was made. While this information can be captured via other methods, using assertions makes it much faster and easier!\n\nThe callback function should accept three arguments. The first argument will contain the file the assertion failed in. The second argument will contain the line the assertion failed on and the third argument will contain the expression that failed (if any - literal values such as 1 or \"two\" will not be passed via this argument)",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "FALSE if the assertion is false, TRUE otherwise.",
    ),
    'args'   => array(
      array(
        'name'   => "assertion",
        'type'   => Variant,
        'desc'   => "The assertion.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "dl",
    'desc'   => "Loads the PHP extension given by the parameter library.\n\nUse extension_loaded() to test whether a given extension is already available or not. This works on both built-in extensions and dynamically loaded ones (either through php.ini or dl()). Warning This function has been removed from some SAPI's in PHP 5.3.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int32,
      'desc'   => "Returns TRUE on success or FALSE on failure. If the functionality of loading modules is not available or has been disabled (either by setting enable_dl off or by enabling safe mode in php.ini) an E_ERROR is emitted and execution is stopped. If dl() fails because the specified library couldn't be loaded, in addition to FALSE an E_WARNING message is emitted.",
    ),
    'args'   => array(
      array(
        'name'   => "library",
        'type'   => String,
        'desc'   => "This parameter is only the filename of the extension to load which also depends on your platform. For example, the sockets extension (if compiled as a shared module, not the default!) would be called sockets.so on Unix platforms whereas it is called php_sockets.dll on the Windows platform.\n\nThe directory where the extension is loaded from depends on your platform:\n\nWindows - If not explicitly set in the php.ini, the extension is loaded from C:\\php4\\extensions\\ (PHP4) or C:\\php5\\ (PHP5) by default.\n\nUnix - If not explicitly set in the php.ini, the default extension directory depends on whether PHP has been built with --enable-debug or not whether PHP has been built with (experimental) ZTS (Zend Thread Safety) support or not the current internal ZEND_MODULE_API_NO (Zend internal module API number, which is basically the date on which a major module API change happened, e.g. 20010901) Taking into account the above, the directory then defaults to <install-dir>/lib/php/extensions/ <debug-or-not>-<zts-or-not>-ZEND_MODULE_API_NO, e.g. /usr/local/php/lib/php/extensions/debug-non-zts-20010901 or /usr/local/php/lib/php/extensions/no-debug-zts-20010901.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "extension_loaded",
    'desc'   => "Finds out whether the extension is loaded.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE if the extension identified by name is loaded, FALSE otherwise.",
    ),
    'args'   => array(
      array(
        'name'   => "name",
        'type'   => String,
        'desc'   => "The extension name.\n\nYou can see the names of various extensions by using phpinfo() or if you're using the CGI or CLI version of PHP you can use the -m switch to list all available extensions: \$ php -m [PHP Modules] xml tokenizer standard sockets session posix pcre overload mysql mbstring ctype [Zend Modules]",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "get_loaded_extensions",
    'desc'   => "This function returns the names of all the modules compiled and loaded in the PHP interpreter.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => StringVec,
      'desc'   => "Returns an indexed array of all the modules names.",
    ),
    'args'   => array(
      array(
        'name'   => "zend_extensions",
        'type'   => Boolean,
        'value'  => "false",
        'desc'   => "Only return Zend extensions, if not then regular extensions, like mysqli are listed. Defaults to FALSE (return regular extensions).",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "get_extension_funcs",
    'desc'   => "This function returns the names of all the functions defined in the module indicated by module_name.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => VariantMap,
      'desc'   => "Returns an array with all the functions, or FALSE if module_name is not a valid extension.",
    ),
    'args'   => array(
      array(
        'name'   => "module_name",
        'type'   => String,
        'desc'   => "The module name.\n\nThis parameter must be in lowercase.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "get_cfg_var",
    'desc'   => "Gets the value of a PHP configuration option.\n\nThis function will not return configuration information set when the PHP was compiled, or read from an Apache configuration file.\n\nTo check whether the system is using a configuration file, try retrieving the value of the cfg_file_path configuration setting. If this is available, a configuration file is being used.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "Returns the current value of the PHP configuration variable specified by option, or FALSE if an error occurs.",
    ),
    'args'   => array(
      array(
        'name'   => "option",
        'type'   => String,
        'desc'   => "The configuration option name.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "get_current_user",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "Returns the username as a string.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "get_defined_constants",
    'desc'   => "Returns the names and values of all the constants currently defined. This includes those created by extensions as well as those created with the define() function.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => VariantMap,
    ),
    'args'   => array(
      array(
        'name'   => "categorize",
        'type'   => Variant,
        'value'  => "null_variant",
        'desc'   => "Causing this function to return a multi-dimensional array with categories in the keys of the first dimension and constants and their values in the second dimension.\n\n\n\nThe above example will output something similar to: Array ( [Core] => Array ( [E_ERROR] => 1 [E_WARNING] => 2 [E_PARSE] => 4 [E_NOTICE] => 8 [E_CORE_ERROR] => 16 [E_CORE_WARNING] => 32 [E_COMPILE_ERROR] => 64 [E_COMPILE_WARNING] => 128 [E_USER_ERROR] => 256 [E_USER_WARNING] => 512 [E_USER_NOTICE] => 1024 [E_ALL] => 2047 [TRUE] => 1 ) [pcre] => Array ( [PREG_PATTERN_ORDER] => 1 [PREG_SET_ORDER] => 2 [PREG_OFFSET_CAPTURE] => 256 [PREG_SPLIT_NO_EMPTY] => 1 [PREG_SPLIT_DELIM_CAPTURE] => 2 [PREG_SPLIT_OFFSET_CAPTURE] => 4 [PREG_GREP_INVERT] => 1 ) [user] => Array ( [MY_CONSTANT] => 1 ) )",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "get_include_path",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "Returns the path, as a string.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "restore_include_path",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => null,
      'desc'   => "No value is returned.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "set_include_path",
    'desc'   => "Sets the include_path configuration option for the duration of the script.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "Returns the old include_path on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "new_include_path",
        'type'   => String,
        'desc'   => "The new value for the include_path",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "get_included_files",
    'desc'   => "Gets the names of all files that have been included using include(), include_once(), require() or require_once().",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => StringVec,
      'desc'   => "Returns an array of the names of all files.\n\nThe script originally called is considered an \"included file,\" so it will be listed together with the files referenced by include() and family.\n\nFiles that are included or required multiple times only show up once in the returned array.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "inclued_get_data",
    'desc'   => "Get the inclued data.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => VariantVec,
      'desc'   => "The inclued data.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "get_magic_quotes_gpc",
    'desc'   => "Returns the current configuration setting of magic_quotes_gpc\n\nKeep in mind that attempting to set magic_quotes_gpc at runtime will not work.\n\nFor more information about magic_quotes, see this security section.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int32,
      'desc'   => "Returns 0 if magic_quotes_gpc is off, 1 otherwise.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "get_magic_quotes_runtime",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int32,
      'desc'   => "Returns 0 if magic_quotes_runtime is off, 1 otherwise.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "get_required_files",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => StringVec,
    ),
  ));

DefineFunction(
  array(
    'name'   => "getenv",
    'desc'   => "Gets the value of an environment variable.\n\nYou can see a list of all the environmental variables by using phpinfo(). Many of these variables are listed within  RFC 3875, specifically section 4.1, \"Request Meta-Variables\".",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "Returns the value of the environment variable varname, or FALSE on an error.",
    ),
    'args'   => array(
      array(
        'name'   => "varname",
        'type'   => String,
        'desc'   => "The variable name.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "getlastmod",
    'desc'   => "Gets the time of the last modification of the current page.\n\nIf you're interested in getting the last modification time of a different file, consider using filemtime().",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int32,
      'desc'   => "Returns the time of the last modification of the current page. The value returned is a Unix timestamp, suitable for feeding to date(). Returns FALSE on error.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "getmygid",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int32,
      'desc'   => "Returns the group ID of the current script, or FALSE on error.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "getmyinode",
    'desc'   => "Gets the inode of the current script.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int32,
      'desc'   => "Returns the current script's inode as an integer, or FALSE on error.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "getmypid",
    'desc'   => "Gets the current PHP process ID.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int32,
      'desc'   => "Returns the current PHP process ID, or FALSE on error.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "getmyuid",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int32,
      'desc'   => "Returns the user ID of the current script, or FALSE on error.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "getopt",
    'desc'   => "Parses options passed to the script.\nThe options parameter may contain the following elements: Individual characters (do not accept values) Characters followed by a colon (parameter requires value) Characters followed by two colons (optional value) Option values are the first argument after the string. It does not matter if a value has leading white space or not. Optional values do not accept \" \" (space) as a separator.\n\nThe format for the options and longopts is almost the same, the only difference is that longopts takes an array of options (where each element is the option) where as options takes a string (where each character is the option).",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => VariantMap,
      'desc'   => "This function will return an array of option / argument pairs or FALSE on failure.\n\nThe parsing of options will end at the first non-option found, anything that follows is discarded.",
    ),
    'args'   => array(
      array(
        'name'   => "options",
        'type'   => String,
        'desc'   => "Each character in this string will be used as option characters and matched against options passed to the script starting with a single hyphen (-). For example, an option string \"x\" recognizes an option -x. Only a-z, A-Z and 0-9 are allowed.",
      ),
      array(
        'name'   => "longopts",
        'type'   => Variant,
        'value'  => "null_variant",
        'desc'   => "An array of options. Each element in this array will be used as option strings and matched against options passed to the script starting with two hyphens (--). For example, an longopts element \"opt\" recognizes an option --opt. Prior to PHP5.3.0 this parameter was only available on few systems",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "getrusage",
    'desc'   => "This is an interface to getrusage(2). It gets data returned from the system call.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => VariantMap,
      'desc'   => "Returns an associative array containing the data returned from the system call. All entries are accessible by using their documented field names.",
    ),
    'args'   => array(
      array(
        'name'   => "who",
        'type'   => Int32,
        'value'  => "0",
        'desc'   => "If who is 1, getrusage will be called with RUSAGE_CHILDREN.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "clock_getres",
    'desc'   => "Gets resolution of system clock. \"man 3 clock_getres\" for more details.",
    'flags'  =>  HasDocComment | HipHopSpecific,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "TRUE if successful, FALSE otherwise",
    ),
    'args'   => array(
      array(
        'name'   => "clk_id",
        'type'   => Int32,
        'desc'   => "Which clock to check.",
      ),
      array(
        'name'   => "sec",
        'type'   => Variant | Reference,
        'desc'   => "Return value in seconds.",
      ),
      array(
        'name'   => "nsec",
        'type'   => Variant | Reference,
        'desc'   => "Return value in nano-seconds.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "clock_gettime",
    'desc'   => "Gets time of a system clock. \"man 3 clock_gettime\" for more details.",
    'flags'  =>  HasDocComment | HipHopSpecific,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "TRUE if successful, FALSE otherwise",
    ),
    'args'   => array(
      array(
        'name'   => "clk_id",
        'type'   => Int32,
        'desc'   => "Which clock.",
      ),
      array(
        'name'   => "sec",
        'type'   => Variant | Reference,
        'desc'   => "Return value in seconds.",
      ),
      array(
        'name'   => "nsec",
        'type'   => Variant | Reference,
        'desc'   => "Return value in nano-seconds.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "clock_settime",
    'desc'   => "Sets time of a system clock. \"man 3 clock_settime\" for more details.",
    'flags'  =>  HasDocComment | HipHopSpecific,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "TRUE if successful, FALSE otherwise",
    ),
    'args'   => array(
      array(
        'name'   => "clk_id",
        'type'   => Int32,
        'desc'   => "Which clock.",
      ),
      array(
        'name'   => "sec",
        'type'   => Int64,
        'desc'   => "Value to set in seconds.",
      ),
      array(
        'name'   => "nsec",
        'type'   => Int64,
        'desc'   => "Value to set in nano-seconds.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "cpu_get_count",
    'desc'   => "Gets number of processors.",
    'flags'  =>  HasDocComment | HipHopSpecific | NoInjection,
    'return' => array(
      'type'   => Int32,
      'desc'   => "Number of CPUs.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "cpu_get_model",
    'desc'   => "Gets processor model.",
    'flags'  =>  HasDocComment | HipHopSpecific | NoInjection,
    'return' => array(
      'type'   => String,
      'desc'   => "Model name of CPU.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "ini_alter",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
    ),
    'args'   => array(
      array(
        'name'   => "varname",
        'type'   => String,
      ),
      array(
        'name'   => "newvalue",
        'type'   => String,
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "ini_get_all",
    'desc'   => "Returns all the registered configuration options.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => VariantMap,
      'desc'   => "Returns an associative array with directive name as the array key.\n\nWhen details is TRUE (default) the array will contain global_value (set in php.ini), local_value (perhaps set with ini_set() or .htaccess), and access (the access level).\n\nWhen details is FALSE the value will be the current value of the option.\n\nSee the manual section for information on what access levels mean.\n\nIt's possible for a directive to have multiple access levels, which is why access shows the appropriate bitmask values.",
    ),
    'args'   => array(
      array(
        'name'   => "extension",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "An optional extension name. If set, the function return only options specific for that extension.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "ini_get",
    'desc'   => "Returns the value of the configuration option on success.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "Returns the value of the configuration option as a string on success, or an empty string on failure or for null values.",
    ),
    'args'   => array(
      array(
        'name'   => "varname",
        'type'   => String,
        'desc'   => "The configuration option name.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "ini_restore",
    'desc'   => "Restores a given configuration option to its original value.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => null,
      'desc'   => "No value is returned.",
    ),
    'args'   => array(
      array(
        'name'   => "varname",
        'type'   => String,
        'desc'   => "The configuration option name.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "ini_set",
    'desc'   => "Sets the value of the given configuration option. The configuration option will keep this new value during the script's execution, and will be restored at the script's ending.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "Returns the old value on success, FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "varname",
        'type'   => String,
        'desc'   => "Not all the available options can be changed using ini_set(). There is a list of all available options in the appendix.",
      ),
      array(
        'name'   => "newvalue",
        'type'   => String,
        'desc'   => "The new value for the option.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "memory_get_peak_usage",
    'desc'   => "Returns the peak of memory, in bytes, that's been allocated to your PHP script.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int64,
      'desc'   => "Returns the memory peak in bytes.",
    ),
    'args'   => array(
      array(
        'name'   => "real_usage",
        'type'   => Boolean,
        'value'  => "false",
        'desc'   => "Set this to TRUE to get the real size of memory allocated from system. If not set or FALSE only the memory used by emalloc() is reported.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "memory_get_usage",
    'desc'   => "Returns the amount of memory, in bytes, that's currently being allocated to your PHP script.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int64,
      'desc'   => "Returns the memory amount in bytes.",
    ),
    'args'   => array(
      array(
        'name'   => "real_usage",
        'type'   => Boolean,
        'value'  => "false",
        'desc'   => "Set this to TRUE to get the real size of memory allocated from system. If not set or FALSE only the memory used by emalloc() is reported.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "php_ini_scanned_files",
    'desc'   => "php_ini_scanned_files() returns a comma-separated list of configuration files parsed after php.ini. These files are found in a directory defined by the --with-config-file-scan-dir option which is set during compilation.\n\nThe returned configuration files also include the path as declared in the --with-config-file-scan-dir option.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "Returns a comma-separated string of .ini files on success. Each comma is followed by a newline. If the directive --with-config-file-scan-dir wasn't set, FALSE is returned. If it was set and the directory was empty, an empty string is returned. If a file is unrecognizable, the file will still make it into the returned string but a PHP error will also result. This PHP error will be seen both at compile time and while using php_ini_scanned_files().",
    ),
  ));

DefineFunction(
  array(
    'name'   => "php_logo_guid",
    'desc'   => "This function returns the ID which can be used to display the PHP logo using the built-in image. Logo is displayed only if expose_php is On.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "Returns PHPE9568F34-D428-11d2-A769-00AA001ACF42.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "php_sapi_name",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "Returns the interface type, as a lowercase string.\n\nAlthough not exhaustive, the possible return values include aolserver, apache, apache2filter, apache2handler, caudium, cgi (until PHP 5.3), cgi-fcgi, cli, continuity, embed, isapi, litespeed, milter, nsapi, phttpd, pi3web, roxen, thttpd, tux, and webjames.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "php_uname",
    'desc'   => "php_uname() returns a description of the operating system PHP is running on. This is the same string you see at the very top of the phpinfo() output. For the name of just the operating system, consider using the PHP_OS constant, but keep in mind this constant will contain the operating system PHP was built on.\n\nOn some older UNIX platforms, it may not be able to determine the current OS information in which case it will revert to displaying the OS PHP was built on. This will only happen if your uname() library call either doesn't exist or doesn't work.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "Returns the description, as a string.",
    ),
    'args'   => array(
      array(
        'name'   => "mode",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "mode is a single character that defines what information is returned: 'a': This is the default. Contains all modes in the sequence \"s n r v m\". 's': Operating system name. eg. FreeBSD. 'n': Host name. eg. localhost.example.com. 'r': Release name. eg. 5.1.2-RELEASE. 'v': Version information. Varies a lot between operating systems. 'm': Machine type. eg. i386.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "phpcredits",
    'desc'   => "This function prints out the credits listing the PHP developers, modules, etc. It generates the appropriate HTML codes to insert the information in a page.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "flag",
        'type'   => Int32,
        'value'  => "0",
        'desc'   => "To generate a custom credits page, you may want to use the flag parameter.\n\nPre-defined phpcredits() flags name description CREDITS_ALL All the credits, equivalent to using: CREDITS_DOCS + CREDITS_GENERAL + CREDITS_GROUP + CREDITS_MODULES + CREDITS_FULLPAGE. It generates a complete stand-alone HTML page with the appropriate tags. CREDITS_DOCS The credits for the documentation team CREDITS_FULLPAGE Usually used in combination with the other flags. Indicates that a complete stand-alone HTML page needs to be printed including the information indicated by the other flags. CREDITS_GENERAL General credits: Language design and concept, PHP authors and SAPI module. CREDITS_GROUP A list of the core developers CREDITS_MODULES A list of the extension modules for PHP, and their authors CREDITS_SAPI A list of the server API modules for PHP, and their authors",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "phpinfo",
    'desc'   => "Outputs a large amount of information about the current state of PHP. This includes information about PHP compilation options and extensions, the PHP version, server information and environment (if compiled as a module), the PHP environment, OS version information, paths, master and local values of configuration options, HTTP headers, and the PHP License.\n\nBecause every system is setup differently, phpinfo() is commonly used to check configuration settings and for available predefined variables on a given system.\n\nphpinfo() is also a valuable debugging tool as it contains all EGPCS (Environment, GET, POST, Cookie, Server) data.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "what",
        'type'   => Int32,
        'value'  => "0",
        'desc'   => "The output may be customized by passing one or more of the following constants bitwise values summed together in the optional what parameter. One can also combine the respective constants or bitwise values together with the or operator.\n\nphpinfo() options Name (constant) Value Description INFO_GENERAL 1 The configuration line, php.ini location, build date, Web Server, System and more. INFO_CREDITS 2 PHP Credits. See also phpcredits(). INFO_CONFIGURATION 4 Current Local and Master values for PHP directives. See also ini_get(). INFO_MODULES 8 Loaded modules and their respective settings. See also get_loaded_extensions(). INFO_ENVIRONMENT 16 Environment Variable information that's also available in \$_ENV. INFO_VARIABLES 32 Shows all predefined variables from EGPCS (Environment, GET, POST, Cookie, Server). INFO_LICENSE 64 PHP License information. See also the  license FAQ. INFO_ALL -1 Shows all of the above.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "phpversion",
    'desc'   => "Returns a string containing the version of the currently running PHP parser or extension.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "If the optional extension parameter is specified, phpversion() returns the version of that extension, or FALSE if there is no version information associated or the extension isn't enabled.",
    ),
    'args'   => array(
      array(
        'name'   => "extension",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "An optional extension name.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "putenv",
    'desc'   => "Adds setting to the server environment. The environment variable will only exist for the duration of the current request. At the end of the request the environment is restored to its original state.\n\nSetting certain environment variables may be a potential security breach. The safe_mode_allowed_env_vars directive contains a comma-delimited list of prefixes. In Safe Mode, the user may only alter environment variables whose names begin with the prefixes supplied by this directive. By default, users will only be able to set environment variables that begin with PHP_ (e.g. PHP_FOO=BAR). Note: if this directive is empty, PHP will let the user modify ANY environment variable!\n\nThe safe_mode_protected_env_vars directive contains a comma-delimited list of environment variables, that the end user won't be able to change using putenv(). These variables will be protected even if safe_mode_allowed_env_vars is set to allow to change them.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "setting",
        'type'   => String,
        'desc'   => "The setting, like \"FOO=BAR\"",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "set_magic_quotes_runtime",
    'desc'   => "Set the current active configuration setting of magic_quotes_runtime. WarningThis function has been DEPRECATED as of PHP 5.3.0. Relying on this feature is highly discouraged.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Boolean,
      'desc'   => "Returns TRUE on success or FALSE on failure.",
    ),
    'args'   => array(
      array(
        'name'   => "new_setting",
        'type'   => Boolean,
        'desc'   => "FALSE for off, TRUE for on.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "set_time_limit",
    'desc'   => "Set the number of seconds a script is allowed to run. If this is reached, the script returns a fatal error. The default limit is 30 seconds or, if it exists, the max_execution_time value defined in the php.ini.\n\nWhen called, set_time_limit() restarts the timeout counter from zero. In other words, if the timeout is the default 30 seconds, and 25 seconds into script execution a call such as set_time_limit(20) is made, the script will run for a total of 45 seconds before timing out.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => null,
      'desc'   => "No value is returned.",
    ),
    'args'   => array(
      array(
        'name'   => "seconds",
        'type'   => Int32,
        'desc'   => "The maximum execution time, in seconds. If set to zero, no time limit is imposed.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "sys_get_temp_dir",
    'desc'   => "Returns the path of the directory PHP stores temporary files in by default.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "Returns the path of the temporary directory.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "version_compare",
    'desc'   => "version_compare() compares two \"PHP-standardized\" version number strings. This is useful if you would like to write programs working only on some versions of PHP.\n\nThe function first replaces _, - and + with a dot . in the version strings and also inserts dots . before and after any non number so that for example '4.3.2RC1' becomes '4.3.2.RC.1'. Then it splits the results like if you were using explode('.', \$ver). Then it compares the parts starting from left to right. If a part contains special version strings these are handled in the following order: any string not found in this list < dev < alpha = a < beta = b < RC = rc < # < pl = p. This way not only versions with different levels like '4.1' and '4.1.2' can be compared but also any PHP specific version containing development state.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Variant,
      'desc'   => "By default, version_compare() returns -1 if the first version is lower than the second, 0 if they are equal, and 1 if the second is lower.\n\nWhen using the optional operator argument, the function will return TRUE if the relationship is the one specified by the operator, FALSE otherwise.",
    ),
    'args'   => array(
      array(
        'name'   => "version1",
        'type'   => String,
        'desc'   => "First version number.",
      ),
      array(
        'name'   => "version2",
        'type'   => String,
        'desc'   => "Second version number.",
      ),
      array(
        'name'   => "sop",
        'type'   => String,
        'value'  => "null_string",
        'desc'   => "If you specify the third optional operator argument, you can test for a particular relationship. The possible operators are: <, lt, <=, le, >, gt, >=, ge, ==, =, eq, !=, <>, ne respectively.\n\nThis parameter is case-sensitive, so values should be lowercase.",
      ),
    ),
  ));

DefineFunction(
  array(
    'name'   => "zend_logo_guid",
    'desc'   => "This function returns the ID which can be used to display the Zend logo using the built-in image.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "Returns PHPE9568F35-D428-11d2-A769-00AA001ACF42.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "zend_thread_id",
    'desc'   => "This function returns a unique identifier for the current thread.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => Int32,
      'desc'   => "Returns the thread id as an integer.",
    ),
  ));

DefineFunction(
  array(
    'name'   => "zend_version",
    'desc'   => "Returns a string containing the version of the currently running Zend Engine.",
    'flags'  =>  HasDocComment,
    'return' => array(
      'type'   => String,
      'desc'   => "Returns the Zend Engine version number, as a string.",
    ),
  ));


///////////////////////////////////////////////////////////////////////////////
// Classes
//
// BeginClass
// array (
//   'name'   => name of the class
//   'desc'   => description of the class's purpose
//   'flags'  => attributes of the class, see base.php for possible values
//   'note'   => additional note about this class's schema
//   'parent' => parent class name, if any
//   'ifaces' => array of interfaces tihs class implements
//   'bases'  => extra internal and special base classes this class requires
//   'footer' => extra C++ inserted at end of class declaration
// )
//
// DefineConstant(..)
// DefineConstant(..)
// ...
// DefineFunction(..)
// DefineFunction(..)
// ...
// DefineProperty
// DefineProperty
//
// array (
//   'name'  => name of the property
//   'type'  => type of the property
//   'flags' => attributes of the property
//   'desc'  => description of the property
//   'note'  => additional note about this property's schema
// )
//
// EndClass()

