/*
   +----------------------------------------------------------------------+
   | HipHop for PHP                                                       |
   +----------------------------------------------------------------------+
   | Copyright (c) 2010- Facebook, Inc. (http://www.facebook.com)         |
   +----------------------------------------------------------------------+
   | This source file is subject to version 3.01 of the PHP license,      |
   | that is bundled with this package in the file LICENSE, and is        |
   | available through the world-wide-web at the following url:           |
   | http://www.php.net/license/3_01.txt                                  |
   | If you did not receive a copy of the PHP license and are unable to   |
   | obtain it through the world-wide-web, please send a note to          |
   | license@php.net so we can mail you a copy immediately.               |
   +----------------------------------------------------------------------+
*/

#include <runtime/eval/ast/constant_expression.h>
#include <runtime/base/externals.h>
#include <runtime/ext/ext_misc.h>
#include <runtime/eval/runtime/eval_state.h>

namespace HPHP {
namespace Eval {
using namespace std;
///////////////////////////////////////////////////////////////////////////////

ConstantExpression::ConstantExpression(EXPRESSION_ARGS,
                                       const string &constant)
  : Expression(EXPRESSION_PASS), m_constant(constant) {}

Variant ConstantExpression::eval(VariableEnvironment &env) const {
  if (m_constant[0] == '\\') {
    Variant ret;
    if (RequestEvalState::findConstant(m_constant.c_str() + 1, ret)) {
      return ret;
    }
    int pos = m_constant.rfind('\\');
    return get_constant(m_constant.c_str() + pos + 1);
  }
  return get_constant(m_constant);
}

bool ConstantExpression::evalStaticScalar(VariableEnvironment &env,
  Variant &r) const {
  if (f_defined(m_constant)) {
    r = get_constant(m_constant);
    return true;
  }
  return false;
}

void ConstantExpression::dump(std::ostream &out) const {
  out << m_constant;
}

///////////////////////////////////////////////////////////////////////////////
}
}

